function Create(self)
	-- print ("RPG brain was born!!!");
	self.HealTimer = Timer();
	self.DisplayTimer = Timer();
	self.Levels = {5 , 15 , 25 , 35 , 45 , 55 , 65 , 75 , 85 , 95}; -- Debug
	-- self.Levels = {50 , 100 , 150 , 200 , 250 , 300 , 350 , 400 , 450 , 500}; -- Gameplay
end
-------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------
function Update(self)
	for actor in MovableMan.Actors do
		if actor.Health < 5 and actor.Team ~= self.Team then
			local preset , exppoints;
			preset, exppoints = ParsePresetName(actor.PresetName);
			
			if exppoints == nil then
				exppoints = 0;
			end
			
			-- Distribute exp only for unmarked actors
			if exppoints >= 0 then
				DistributeExp(actor , self);

				-- Mark that we already gained experience points from this actor
				actor.PresetName = MakePresetName(preset , -1000);
				
				-- Destroy actor
				if math.random() < 0.85 then
					actor:GibThis();
				else
					actor.Health = -1;
				end
			end
		end -- if
	end -- for
	
	-- Add health
	if self.HealTimer:IsPastSimMS(1500) then
		for actor in MovableMan.Actors do
			if actor.Health > 5 and actor.Health < 100 and actor.Team == self.Team then
				local health2add = 0;
				local actorlevel = GetActorLevel(actor , self);
				
				health2add = actorlevel;
				
				if actorlevel > 7 then
					health2add = actorlevel * 2;
				end
				
				if health2add > 0 then
					local effect = CreateMOSParticle("Particle Heal Effect");
					effect.Pos = actor.AboveHUDPos + Vector(0 , 12);
					effect.ToSettle = false;
					MovableMan:AddParticle(effect);
				end
				
				actor.Health = actor.Health + health2add;
				if actor.Health > 100 then
					actor.Health = 100;
				end
			end

			self.HealTimer:Reset();
		end
	end
	
	if self.DisplayTimer:IsPastSimMS(3350) then
		-- Show current actor level		
		local curactor = ActivityMan:GetActivity():GetControlledActor(self.Team);
		if MovableMan:IsActor(curactor) then
			local actorlevel = GetActorLevel(curactor , self);

			if actorlevel > 0 then
				local effectpreset = string.format("Level%d" , actorlevel);
				local effect = CreateMOSParticle(effectpreset , "UnmappedLands.rte");
				effect.Pos = curactor.AboveHUDPos + Vector(0 , 5);
				effect.ToSettle = false;
				MovableMan:AddParticle(effect);
			end
		end

		-- Show elite actor marks
		local elitecount = 2;
		local eliteexp = {};
		local eliteactors = {};
		
		for i = 1 , elitecount do
			eliteexp[i] = 0;
			eliteactors[i] = nil;
		end
		
		-- Find toughest elite actors
		for actor in MovableMan.Actors do
			if actor.Team == self.Team and GetActorLevel(actor , self) > 0 then
				local presetname , actorexp;
				
				presetname , actorexp = ParsePresetName(actor.PresetName);
				
				if actorexp ~= nil then
					for j = 1 , elitecount do
						if actorexp >= eliteexp[j] then
							for i = j + 1 , elitecount do
								eliteexp[i] = eliteexp[i - 1];
								eliteactors[i] = eliteactors[i - 1];
							end
							
							eliteexp[j] = actorexp;
							eliteactors[j] = actor;
							break;
						end
					end
				end
			end
		end
		
		for i = 1 , elitecount do
			if eliteactors[i] ~= nil and MovableMan:IsActor(eliteactors[i]) then
				local effect = CreateMOSParticle("Elite" , "UnmappedLands.rte");
				effect.Pos = eliteactors[i].AboveHUDPos + Vector(0 , -6);
				effect.ToSettle = false;
				MovableMan:AddParticle(effect);
			end
		end
		
		self.DisplayTimer:Reset();
	end
end
-------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------
function ParsePresetName(s)
	local pos;
	
	pos = string.find(s ,":");
	
	if pos ~= nil then
		local  preset , exppoints;

		--s = string.gsub(s , "\n" , "");
		preset = string.sub(s , 1 , pos - 1);
		exppoints = string.sub(s , pos + 1 , string.len(s));

		return preset , tonumber(exppoints);
	else
		return s , nil;
	end
end
-------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------
function MakePresetName(preset , exppoints)
	return preset..":"..exppoints
end
-------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------
function GetActorLevel(actor , self)
	local actorlevel = 0;
	local presetname , actorexp;
	presetname , actorexp = ParsePresetName(actor.PresetName);
			
	if actorexp ~= nil then
		for i = 1 , #self.Levels do
			if actorexp > self.Levels[i] then
				actorlevel = i;
			end
		end
	end

	return actorlevel;
end
-------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------
function DistributeExp(deadactor , self)
	local friendlyactors = 0;
	local basicexp;
	local exp2add = 0;
	local actorlevel;
	local lastactorlevel;
	
	-- Count to how many actors we need to distribute exp points
	for actor in MovableMan.Actors do
		if actor.ClassName ~= "ADoor" and actor.ClassName ~= "ACDropShip" and actor.ClassName ~= "ACRocket" then
			if actor.Health >= 1 and actor.Team == self.Team and string.find(actor.PresetName , "Brain") == nil then
				friendlyactors = friendlyactors + 1;
			end
		end
	end
	
	-- Calc how much exppoints to give each actor
	exp2add = 10;
	if deadactor.ClassName == "AHuman" then
		exp2add = 30;
	elseif deadactor.ClassName == "ACrab" then
		exp2add = 45;
	elseif deadactor.ClassName == "ACraft" or deadactor.ClassName == "ACDropship" or deadactor.ClassName == "ACRocket" then
		exp2add = 90;
	end

	local deadpresetname, deadactorexp;
	deadpresetname , deadactorexp = ParsePresetName(deadactor.PresetName);

	if deadactorexp ~= nil then
		exp2add = exp2add + (deadactorexp * 1.5);
	end
	
	basicexp = exp2add;
	
	exp2add = math.ceil(exp2add / friendlyactors);
	
	print ("CCRPG: Distributed "..basicexp.."/"..exp2add.." exp points among "..friendlyactors.." actors for dead "..deadactor.PresetName);
	
	-- Ditribute exp points amoung friendly actors
	for actor in MovableMan.Actors do
		if actor.ClassName ~= "ADoor" and actor.ClassName ~= "ACRocket" and actor.ClassName ~= "ACDropShip" then
			if actor.Health >= 5 and actor.Team == self.Team and string.find(actor.PresetName , "Brain") == nil then
				lastactorlevel = GetActorLevel(actor , self);
				
				local presetname, actorexp;
				presetname , actorexp = ParsePresetName(actor.PresetName);

				if actorexp ~= nil then
					actorexp = actorexp + exp2add;
					actor.PresetName = MakePresetName(presetname , actorexp);
				else
					actor.PresetName = MakePresetName(presetname , exp2add);
				end
				
				actorlevel = GetActorLevel(actor , self);
				
				if actorlevel > lastactorlevel then
					local effect = CreateMOSParticle("LevelUp" , "UnmappedLands.rte");
					effect.Pos = actor.AboveHUDPos + Vector(0 , 16);
					effect.ToSettle = false;
					MovableMan:AddParticle(effect);
				end
			end
		end
	end
end


