-----------------------------------------------------------------------------------------
-- Generic functions to add to library
-----------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-- Initialize global faction lists
-----------------------------------------------------------------------------------------
function CF_InitFactions()
	print ("CF_InitFactions");
   	CF_CPUTeam = Activity.TEAM_2;
	CF_PlayerTeam = Activity.TEAM_1;
	CF_RogueTeam = -1;
	CF_MOIDLimit = 220;
	CF_AIBudget = 0;

	CF_Factions = {COALITION = 1 , DUMMY = 2 , RONIN = 3 , NOBODY = 4 , BEARFORCE = 5};

	CF_PlayerFaction = CF_Factions.NOBODY;
	CF_CPUFaction = CF_Factions.NOBODY;

	CF_ForeignCheckTimer = Timer();
	CF_ForeignCheckTimer:Reset();

	
	CF_MissionEndTimer = Timer();
	CF_StartReturnCountdown = false;
	CF_Activity = ActivityMan:GetActivity();
	
	CF_FactionModules = {};
	CF_LightWeaponSets = {};
	CF_HeavyWeaponSets = {};
	CF_ExplosiveSets = {};
	CF_ActorSets = {};
	CF_BrainPresets = {};
	CF_Probabilities = {};
	CF_AllowedActors = {};
	CF_InfantryModules = {};	
	
	CF_BasicActorPrice = 90;
	CF_BasicItemPrice = 90;
	CF_BasicLightWeaponPrice = 60;
	CF_BasicHeavyWeaponPrice = 140;
	CF_BasicExplosivePrice = 12;
	CF_BasicDropshipPrice = 115;
	
	CF_InfantryModules[CF_Factions.COALITION] = "Coalition.rte";
	CF_InfantryModules[CF_Factions.DUMMY] = "Dummy.rte";
	CF_InfantryModules[CF_Factions.RONIN] = "Ronin.rte";
	CF_InfantryModules[CF_Factions.NOBODY] = "Base.rte";
	CF_InfantryModules[CF_Factions.BEARFORCE] = "BF.rte";

	-- Different probabilities.
	-- 1 - Probability to get a heavy weapon
	-- 2 - Probability to get a secondary weapon
	-- 3 - Probability to get an explosive
	-- 4 - Probability to a second explosive
	-- Example:
	-- self.Probabilities[self.Factions.CLONE] = {0.35 , 0.30 , 0.60 , 0.30};
	CF_LightWeaponSets[CF_Factions.COALITION] = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle" , "Grenade Launcher" }
	CF_HeavyWeaponSets[CF_Factions.COALITION] = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Grenade Launcher" , "Uber Cannon" , "Revolver Cannnon"}
	CF_ExplosiveSets[CF_Factions.COALITION] = {"Grenade"};
	CF_ActorSets[CF_Factions.COALITION] = {"Soldier Light" , "Soldier Heavy"};
	CF_BrainPresets[CF_Factions.COALITION] = "Coalition Brain";
	CF_Probabilities[CF_Factions.COALITION] = {0.35 , 0.30 , 0.30 , 0.15};
	CF_AllowedActors[CF_Factions.COALITION] = {"Coalition Brain" , "Soldier Light" , "Soldier Heavy" , "Drone" , "Medic Drone" , "Drop Ship MK1" , "Rocket MK1" , "Rocket MK2"};
	
	CF_LightWeaponSets[CF_Factions.DUMMY] = {"Rail Pistol", "Nailgun" , "Blaster" , "Sniper Rifle" , "Nailer Cannon" }
	CF_HeavyWeaponSets[CF_Factions.DUMMY] = {"Blaster" , "Sniper Rifle" , "Nailer Cannon" , "Repeater" , "Grenade Launcher" , "Destroyer Cannon" , "Annihiliator"}
	CF_ExplosiveSets[CF_Factions.DUMMY] = {"Impulse Grenade"};
	CF_ActorSets[CF_Factions.DUMMY] = {"Dummy"};
	CF_BrainPresets[CF_Factions.DUMMY] = "Dummy Brain";
	CF_Probabilities[CF_Factions.DUMMY] = {0.65 , 0.35 , 0.30 , 0.15};
	CF_AllowedActors[CF_Factions.DUMMY] = {"Dummy Brain" , "Dummy" , "Dreadnought" , "Drop Ship" , "Rocklet" , "Drop Crate"};

	CF_LightWeaponSets[CF_Factions.RONIN] = {"Peacemaker", "TommyGun" , "Uzi" , "Shortgun" , "Rifle Long" , "Pumpgun" }
	CF_HeavyWeaponSets[CF_Factions.RONIN] = {"M16", "YAK47" , "M1600" , "Sniper Rifle" , "Spaz12" , "Bazooka" , "Spaz1200"}
	CF_ExplosiveSets[CF_Factions.RONIN] = {"Pineapple Grenade" , "Stick Grenade"};
	CF_ActorSets[CF_Factions.RONIN] = {"Mia" , "Dimitri" , "Sandra" , "Gordon"};
	CF_BrainPresets[CF_Factions.RONIN] = "Ronin Brain";
	CF_Probabilities[CF_Factions.RONIN] = {0.35 , 0.30 , 0.30 , 0.15};
	CF_AllowedActors[CF_Factions.RONIN] = {"Ronin Brain" , "Dafred" , "Mia" , "Brutus" , "Dimitri" , "Sandra" , "Gordon", "Drop Ship MK1" , "Rocket MK1" , "Rocket MK2"};

	CF_LightWeaponSets[CF_Factions.NOBODY] = {"Blaster Pistol" }
	CF_HeavyWeaponSets[CF_Factions.NOBODY] = {"Laser Rifle"}
	CF_ExplosiveSets[CF_Factions.NOBODY] = {"Frag Grenade"};
	CF_ActorSets[CF_Factions.NOBODY] = {"Coalition Brain"};
	CF_BrainPresets[CF_Factions.NOBODY] = "Brain Robot";
	CF_Probabilities[CF_Factions.NOBODY] = {0.35 , 0.30 , 0.30 , 0.15};
	CF_AllowedActors[CF_Factions.NOBODY] = {"Robot 1" , "Robot 2" , "Crab" , "Drop Ship MK1" , "Rocket MK1" , "Rocket MK2"};

	CF_LightWeaponSets[CF_Factions.BEARFORCE] = {"PMa" , "PPC-3" , "AK-101"}
	CF_HeavyWeaponSets[CF_Factions.BEARFORCE] = {"VGe Gauss Rifle" , "SVDh" , "VSS" , "RPG-7", "RG-6"}
	CF_ExplosiveSets[CF_Factions.BEARFORCE] = {"F1 granade"};
	CF_ActorSets[CF_Factions.BEARFORCE] = {"BF Conscript 1" , "BF Conscript 2" , "BF Conscript 3" , "BF Spetsnaz 1" , "BF Spetsnaz 2" , "BF Spetsnaz 3"};
	CF_BrainPresets[CF_Factions.BEARFORCE] = "Bearforce Brain";
	CF_Probabilities[CF_Factions.BEARFORCE] = {0.35 , 0.30 , 0.30 , 0.15};
	CF_AllowedActors[CF_Factions.BEARFORCE] = {"Bearforce Brain" , "BF Conscript 1" , "BF Conscript 2" , "BF Conscript 3" , "BF Spetsnaz 1" , "BF Spetsnaz 2" , "BF Spetsnaz 3" , "BF Drop Ship"};
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_MakeWeapon(faction , islight)
	print ("CF_MakeWeapon");

	local weapon;
	local r1 , r2;
	local price;
	
	weapon = nil;
	r1 = math.random(#CF_LightWeaponSets[faction]);
	r2 = math.random(#CF_HeavyWeaponSets[faction]);
	
	if islight then
		weapon = CreateHDFirearm(CF_LightWeaponSets[faction][r1] , CF_InfantryModules[faction]);
		price = CF_BasicLightWeaponPrice;
	else
		weapon = CreateHDFirearm(CF_HeavyWeaponSets[faction][r2] , CF_InfantryModules[faction]);
		price = CF_BasicHeavyWeaponPrice;
	end
	
	return weapon , price;
end
-----------------------------------------------------------------------------------------
-- Make explosive. faction - actor faction number
-----------------------------------------------------------------------------------------
function CF_MakeExplosive(faction)
	print ("CF_MakeExplosive");
	local weapon;
	local r;
	
	weapon = nil;
	r = math.random(#CF_ExplosiveSets[faction]);
	
	weapon = CreateTDExplosive(CF_ExplosiveSets[faction][r] , CF_InfantryModules[faction]);
	
	return weapon , CF_BasicExplosivePrice;
end
-----------------------------------------------------------------------------------------
-- Spawn brain of selected faction. Returns actor or nil if custom position is used
-----------------------------------------------------------------------------------------
function CF_SpawnBrain(team , pos , faction , aimode)
	print ("CF_SpawnBrain");
	local actor = nil;
	local r;
	local weapon;
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		if faction == CF_Factions.COALITION then
			actor = CreateAHuman("Coalition Brain" , "UnmappedLands.rte");
		elseif faction == CF_Factions.DUMMY then
			actor = CreateAHuman("Dummy Brain" , "UnmappedLands.rte");
		elseif faction == CF_Factions.RONIN then
			actor = CreateAHuman("Ronin Brain" , "UnmappedLands.rte");
		elseif faction == CF_Factions.BEARFORCE then
			actor = CreateAHuman("Bearforce Brain" , "UnmappedLands.rte");
		end

		-- Give brain one light weapon
		weapon , price = CF_MakeWeapon(faction , true);
		actor:AddInventoryItem(weapon);
		
		actor.AIMode = aimode;
		actor.Team = team;
		
		if pos ~= nil then
			actor.Pos = pos;
			MovableMan:AddActor(actor);
		else
			return actor;
		end
	end
	
	return nil;
end
-----------------------------------------------------------------------------------------
-- Spawns dropship of selected faction. Returns actor, price.
-----------------------------------------------------------------------------------------
function CF_SpawnDropship(team , pos , faction)
	print ("CF_SpawnDropship");
	local actor = nil;
	local r;
	local price;
	
	price = 0;
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		if faction == CF_Factions.COALITION then
			actor = CreateACDropShip("Drop Ship MK1" , "Base.rte");
			price = CF_BasicDropshipPrice;
		elseif faction == CF_Factions.DUMMY then
			actor = CreateACDropShip("Drop Ship" , "Dummy.rte");
			price = CF_BasicDropshipPrice;
		elseif faction == CF_Factions.RONIN then
			actor = CreateACDropShip("Drop Ship MK1" , "Base.rte");
		elseif faction == CF_Factions.BEARFORCE then
			actor = CreateACDropShip("BF Drop Ship" , "BF.rte");
			price = CF_BasicDropshipPrice;
		end
		
		actor.AIMode = Actor.AIMODE_DELIVER;
		actor.Team = team;
		actor.Pos = pos;
		actor:SetControllerMode(Controller.CIM_AI, -1);

		return actor , price;
	end
	
	return nil , price;
end
-----------------------------------------------------------------------------------------
-- Spawns armor of selected faction. Returns actor, price.
-----------------------------------------------------------------------------------------
function CF_SpawnArmor(team , pos , faction , aimode)
	print ("CF_SpawnArmor");
	local actor = nil;
	local r;
	local price;
	
	price = 0;
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		if faction == CF_Factions.COALITION then
			actor = CreateAHuman("Soldier Heavy" , "Coalition.rte");
			actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , "Base.rte"));
			actor:AddInventoryItem(CreateHDFirearm("Compact Submachinegun" , "UnmappedLands.rte"));
			price = CF_BasicActorPrice + CF_BasicLightWeaponPrice + 20;
		elseif faction == CF_Factions.DUMMY then
			actor = CreateACrab("Dreadnought" , "Dummy.rte");
			price = 200;
		elseif faction == CF_Factions.RONIN then
			actor = CreateAHuman("Brutus" , "Ronin.rte");
			actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , "Base.rte"));
			actor:AddInventoryItem(CreateHDFirearm("Vakidzasi" , "UnmappedLands.rte"));
			price = CF_BasicActorPrice + CF_BasicLightWeaponPrice + 20;
		elseif faction == CF_Factions.BEARFORCE then
			actor = CreateAHuman("BF Spetsnaz 3" , "BF.rte");
			actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , "Base.rte"));
			actor:AddInventoryItem(CreateHDFirearm("PMa" , "BF.rte"));
			price = CF_BasicActorPrice + CF_BasicLightWeaponPrice + 20;
		end
		
		actor.AIMode = aimode;
		actor.Team = team;
		
		if pos ~= nil then
			actor.Pos = pos;
			MovableMan:AddActor(actor);
		else
			return actor , price;
		end
	end
	
	return nil , price;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_SpawnRandomInfantry(team , pos , faction , aimode)
	print ("CF_SpawnRandomInfantry");
	local actor = nil;
	local r;
	local totalprice;
	local price;
	local item;
	
	price = 0;
	totalprice = 0;
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		r = math.random(#CF_ActorSets[faction]);
		actor = CreateAHuman(CF_ActorSets[faction][r] , CF_InfantryModules[faction]);
		--print (actor.GoldCost);
		totalprice = totalprice + CF_BasicActorPrice;

		-- probability to give a secondary weapon
		-- which is always light
		if math.random() < CF_Probabilities[faction][2] then
			item , price = CF_MakeWeapon(faction , true);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		end
		
		-- probability to give a heavy weapon
		if math.random() < CF_Probabilities[faction][1] then
			item , price = CF_MakeWeapon(faction , false);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		else
			item , price = CF_MakeWeapon(faction , true);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		end
		
		-- probability to give an explosive
		if math.random() < CF_Probabilities[faction][3] then
			item , price = CF_MakeExplosive(faction);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		end

		-- probability to give a second explosive
		if math.random() < CF_Probabilities[faction][4] then
			item , price = CF_MakeExplosive(faction);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		end
		
		actor.AIMode = aimode;
		actor.Team = team;
		
		if pos ~= nil then
			actor.Pos = pos;
			MovableMan:AddActor(actor);
		else
			return actor , totalprice;
		end
	end
	
	return nil , totalprice;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_SpawnInfantry(givelight , giveheavy , giveexplosive , givedigger , team , pos , faction , aimode)
	print ("CF_SpawnInfantry");
	local actor = nil;
	local r;
	local totalprice;
	local price;
	local item;
	
	price = 0;
	totalprice = 0;	
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		r = math.random(#CF_ActorSets[faction]);
		actor = CreateAHuman(CF_ActorSets[faction][r] , CF_InfantryModules[faction]);
		totalprice = totalprice + CF_BasicActorPrice;
		
		if givelight then
			item , price = CF_MakeWeapon(faction , true);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		end

		if giveheavy then
			item , price = CF_MakeWeapon(faction , false);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		end
		
		-- probability to give an explosive
		if giveexplosive then
			item , price = CF_MakeExplosive(faction);
			actor:AddInventoryItem(item);
			totalprice = totalprice + price;
		end
		
		actor.AIMode = aimode;
		actor.Team = team;

		if pos ~= nil then
			actor.Pos = pos;
			MovableMan:AddActor(actor);
		else
			return actor , totalprice;
		end
	end
	
	return nil , totalprice;
end
-----------------------------------------------------------------------------------------
-- Places garrison troopers on the map
-----------------------------------------------------------------------------------------
function CF_ArrangeGarrisonActors(config)
	print ("CF_ArrangeGarrisonActors");
	local troops;
	
	troops = config["Planet"..config["LastMissionTerritory"].."Troopers"];
	
	print ("Troops "..troops);

	for i = 1, troops do
		CF_SpawnInfantry(false , true , true , false ,
			CF_PlayerTeam , SceneMan.Scene:GetArea("Garrison"..i):GetCenterPoint() , 
			CF_PlayerFaction , Actor.AIMODE_SENTRY);
	end
end

-----------------------------------------------------------------------------------------
-- Creates experienced elite actor taken from previous battles
-----------------------------------------------------------------------------------------
function CF_SpawnElite(presetnameexp , team , pos , faction , aimode)
	print("CF_SpawnEilte");
	local actor = nil;
	local r;
	local price;
	local presetname , exppoints;
	
	presetname , exppoints = CF_ParsePresetName(presetnameexp);
	
	price = 0;
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		if faction == CF_Factions.COALITION then
			actor = CreateAHuman(presetname , CF_InfantryModules[faction]);
			actor.PresetName = presetnameexp;
			actor:AddInventoryItem(CreateHDFirearm("Revolver Cannnon" , CF_InfantryModules[faction]));
			actor:AddInventoryItem(CreateHDFirearm("Assault Rifle" , CF_InfantryModules[faction]));
			
			price = CF_BasicActorPrice + CF_BasicHeavyWeaponPrice + CF_BasicLightWeaponPrice;
		elseif faction == CF_Factions.DUMMY then
			actor = CreateAHuman(presetname , CF_InfantryModules[faction]);
			actor.PresetName = presetnameexp;
			actor:AddInventoryItem(CreateHDFirearm("Repeater" , CF_InfantryModules[faction]));
			actor:AddInventoryItem(CreateHDFirearm("Blaster" , CF_InfantryModules[faction]));
			
			price = CF_BasicActorPrice + CF_BasicHeavyWeaponPrice + CF_BasicLightWeaponPrice;
		elseif faction == CF_Factions.RONIN then
			actor = CreateAHuman(presetname , CF_InfantryModules[faction]);
			actor.PresetName = presetnameexp;
			actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle" , CF_InfantryModules[faction]));
			actor:AddInventoryItem(CreateHDFirearm("M16" , CF_InfantryModules[faction]));
			
			price = CF_BasicActorPrice + CF_BasicHeavyWeaponPrice + CF_BasicLightWeaponPrice;
		elseif faction == CF_Factions.BEARFORCE then
			actor = CreateAHuman(presetname , CF_InfantryModules[faction]);
			actor.PresetName = presetnameexp;
			actor:AddInventoryItem(CreateHDFirearm("AK-101" , CF_InfantryModules[faction]));
			actor:AddInventoryItem(CreateHDFirearm("RG-6" , CF_InfantryModules[faction]));
			
			price = CF_BasicActorPrice + CF_BasicHeavyWeaponPrice + CF_BasicLightWeaponPrice;
		end
		
		actor.AIMode = aimode;
		actor.Team = team;
		
		if pos ~= nil then
			actor.Pos = pos;
			MovableMan:AddActor(actor);
		else
			return actor , price;
		end
	end
	
	return nil , price;
end
-----------------------------------------------------------------------------------------
-- Deploy elite actors
-----------------------------------------------------------------------------------------
function CF_ArrangeEliteActors(config)
	print ("CF_ArrangeEliteActors");

	for i = 1, tonumber(config["MaxElite"]) do
		if config["Elite"..i] ~= "None" then
			CF_SpawnElite(config["Elite"..i] , CF_PlayerTeam , 
				SceneMan.Scene:GetArea("Elite"..i):GetCenterPoint() , CF_PlayerFaction , Actor.AIMODE_SENTRY);
		end
	end
end
-----------------------------------------------------------------------------------------
-- Replace default dummy actors placed manually to faction-specific actors
-----------------------------------------------------------------------------------------
function CF_ReplaceAddedActors(config)
	print ("CF_ReplaceAddedActors");
	local team;
	local toremove;
	local lpos;
	local viewpoint;
	local colls = {};
    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
		toremove = false;
		
		if actor.Team ~= CF_RogueTeam then
			print(actor.PresetName);
			-- Replace existing dummy actors with custom ones  
			-- Replace brain units
			if actor.PresetName == "Dummy Brain" then
				lpos = Vector(actor.Pos.X , actor.Pos.Y);
				actor.Pos = Vector(0 , - 20);
				toremove = true;
				if actor.Team == CF_PlayerTeam then
					CF_SpawnBrain(CF_PlayerTeam , lpos , CF_PlayerFaction , Actor.AIMODE_SENTRY);
				else
					CF_SpawnBrain(CF_CPUTeam , lpos , CF_CPUFaction , Actor.AIMODE_SENTRY);
				end
			end

			-- Replace soldier units
			if actor.PresetName == "Dummy" then
				lpos = Vector(actor.Pos.X , actor.Pos.Y);
				actor.Pos = Vector(0 , - 20);
				toremove = true;
				if actor.Team == CF_PlayerTeam then
					CF_SpawnRandomInfantry(CF_PlayerTeam , lpos , CF_PlayerFaction , Actor.AIMODE_SENTRY);
				else
					CF_SpawnRandomInfantry(CF_CPUTeam , lpos , CF_CPUFaction , Actor.AIMODE_SENTRY);
				end
			end

			-- Replace armor units
			if actor.PresetName == "Dreadnought" then
				lpos = Vector(actor.Pos.X , actor.Pos.Y);
				actor.Pos = Vector(0 , - 20);
				toremove = true;
				if actor.Team == CF_PlayerTeam then
					CF_SpawnArmor(CF_PlayerTeam , lpos , CF_PlayerFaction , Actor.AIMODE_SENTRY);
				else
					CF_SpawnArmor(CF_CPUTeam , lpos , CF_CPUFaction , Actor.AIMODE_SENTRY);
				end
			end
		end
		
		if toremove then 
			MovableMan:RemoveActor(actor);
		end
    end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_GetCPUFaction(config)
	print ("CF_GetCPUFaction");
	faction = config["LastMissionCPUFaction"];

	if faction == "Coalition" then
		return CF_Factions.COALITION;
	elseif faction == "Dummy" then
		return CF_Factions.DUMMY;
	elseif faction == "Ronin" then
		return CF_Factions.RONIN;
	elseif faction == "Nobody" then
		return CF_Factions.NOBODY;
	elseif faction == "Bearforce" then
		return CF_Factions.BEARFORCE;
	end
	
	return CF_Factions.NOBODY;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_GetPlayerFaction(config)
	print ("CF_GetPlayerFaction");
	faction = config["PlayerFaction"];

	if faction == "Coalition" then
		return CF_Factions.COALITION;
	elseif faction == "Dummy" then
		return CF_Factions.DUMMY;
	elseif faction == "Ronin" then
		return CF_Factions.RONIN;
	elseif faction == "Nobody" then
		return CF_Factions.NOBODY;
	elseif faction == "Bearforce" then
		return CF_Factions.BEARFORCE;
	end
	
	return CF_Factions.NOBODY;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_CountLoot()
	print ("CF_CountLoot");
	local troops;
	local loot;
	
	troops = 0;
	loot = 0;
	
	for actor in MovableMan.Actors do
		if actor.Team == CF_PlayerTeam then
			if actor.PresetName ~= "Brain Robot" and actor.PresetName ~= "Dummy Brain" and
				actor.PresetName ~= "Ronin Brain" then
				troops = troops + 1;
			end
			
			if troops > 5 then
				loot = loot + (actor.Health / 100 * CF_BasicActorPrice);
			end
		end
	end
	
	print ("Actor loot = "..loot);

	for item in MovableMan.Items do
		loot = loot + CF_BasicItemPrice;
	end

	print ("Total loot = "..loot);
	
	return math.ceil(loot);
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_CountRemainingTroopers()
	print ("CF_CountRemainingTroopers");
	local troops;
	
	troops = 0;
	
	for actor in MovableMan.Actors do
		if actor.Team == CF_PlayerTeam then
			if actor.PresetName ~= "Brain Robot" and actor.PresetName ~= "Dummy Brain" and
				actor.PresetName ~= "Ronin Brain" then
				troops = troops + 1;
			end
			
			if troops == 5 then
				break;
			end
		end
	end -- for
	
	return troops;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_UpdateGenericStats(config)
	print ("CF_UpdateGenericStats");

	config["PlayerGold"] = CF_Activity:GetTeamFunds(CF_PlayerTeam);
	config["Kills"] = tonumber(config["Kills"]) + CF_Activity:GetTeamDeathCount(CF_CPUTeam);
	config["Deaths"] = tonumber(config["Deaths"]) + CF_Activity:GetTeamDeathCount(CF_PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Save most experienced actors data to config
-----------------------------------------------------------------------------------------
function CF_CommitElite(config)
	print ("CF_CommitElite");
	-- Show elite actor marks
	local elitecount;
	local eliteexp = {};
	local eliteactors = {};
	
	elitecount = tonumber(config["MaxElite"]);
	
	for i = 1 , elitecount do
		eliteexp[i] = 0;
		eliteactors[i] = nil;
	end
	
	-- Find toughest elite actors
	for actor in MovableMan.Actors do
		if actor.Team == CF_PlayerTeam then
			local presetname , actorexp;
			
			presetname , actorexp = CF_ParsePresetName(actor.PresetName);
			
			if actorexp ~= nil then
				for j = 1 , elitecount do
					if actorexp >= eliteexp[j] then
						for i = j + 1 , elitecount do
							eliteexp[i] = eliteexp[i - 1];
							eliteactors[i] = eliteactors[i - 1];
						end
						
						eliteexp[j] = actorexp;
						eliteactors[j] = actor;
						break;
					end
				end
			end
		end
	end
	
	for i = 1 , elitecount do
		if eliteactors[i] ~= nil and MovableMan:IsActor(eliteactors[i]) then
			config["Elite"..i] = eliteactors[i].PresetName;
		else
			config["Elite"..i] = "None";
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_InitMission(config)
	print ("CF_InitMission");

	CF_Activity:SetTeamFunds(tonumber(config["PlayerGold"]) , CF_PlayerTeam);
	CF_AIBudget = tonumber(config["LastMissionAIBudget"]);

	CF_PlayerFaction = CF_GetPlayerFaction(config);
	CF_CPUFaction = CF_GetCPUFaction(config);
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_CommitVictory(config , modulename ,  filename)
	if CF_Activity.ActivityState ~= Activity.OVER then
		print ("CF_CommitVictory");
		config["LastMissionResult"] = "Victory";
		config["LastMissionLootCollected"] = CF_CountLoot();
		config["Planet"..config["LastMissionTerritory"].."Troopers"] = CF_CountRemainingTroopers();
		CF_UpdateGenericStats(config);
		CF_CommitElite(config);
		
		CF_WriteConfigFile(config , modulename , filename);
		
		for player = 0, CF_Activity.PlayerCount - 1 do
			FrameMan:SetScreenText("VICTORY!!!", player, 200, -1, false);
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_CommitRetreat(config , modulename , filename)
	if CF_Activity.ActivityState ~= Activity.OVER then
		print ("CF_CommitRetreat");
		
		config["LastMissionResult"] = "Retreat";
		config["LastMissionLootCollected"] = "0";
		config["Planet"..config["LastMissionTerritory"].."Troopers"] = "0";
		CF_UpdateGenericStats(config);
		
		-- Clear elite troopers
		for i = 1 , tonumber(config["MaxElite"]) do
			config["Elite"..i] = "None";
		end		
		
		CF_WriteConfigFile(config , modulename , filename);

		for player = 0, CF_Activity.PlayerCount - 1 do
			FrameMan:SetScreenText("RETREAT!!!", player, 200, -1, false);
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_CommitDefeat(config , modulename , filename)
	if CF_Activity.ActivityState ~= Activity.OVER then
		print ("CF_CommitDefeat");

		config["LastMissionResult"] = "Defeat";
		config["LastMissionLootCollected"] = "0"
		config["Planet"..config["LastMissionTerritory"].."Troopers"] = "0";
		config["PlayerHasBrain"] = "false";
		CF_UpdateGenericStats(config);

		-- Clear elite troopers
		for i = 1 , tonumber(config["MaxElite"]) do
			config["Elite"..i] = "None";
		end		
		
		CF_WriteConfigFile(config , modulename , filename);

		for player = 0, CF_Activity.PlayerCount - 1 do
			FrameMan:SetScreenText("COMMANDER DEAD! DEFEAT!!!", player, 200, -1, false);
		end
	end
end
-----------------------------------------------------------------------------------------
-- Transfers player to strategy screen after 3 second of victory message
-----------------------------------------------------------------------------------------
function CF_ReturnOnMissionEnd()
	if not CF_StartReturnCountdown then
		if CF_Activity.ActivityState == Activity.OVER then
			CF_StartReturnCountdown = true;
			CF_MissionEndTimer:Reset();
		end
	end
	
	if CF_StartReturnCountdown then
		if CF_MissionEndTimer:IsPastSimMS(3000) then
			print ("Transfer to strategy screen");
			ActivityMan:EndActivity();
			ActivityMan:StartActivity("GAScripted" , "StrategyScreen");
		end
	end
end
-------------------------------------------------------------------------------
-- Parses given presetname into Preset : Experience tuple
-------------------------------------------------------------------------------
function CF_ParsePresetName(s)
	local pos1 , pos2;
	
	pos = string.find(s ,":");
	
	if pos ~= nil then
		local  preset , exppoints;

		--s = string.gsub(s , "\n" , "");
		preset = string.sub(s , 1 , pos - 1);
		exppoints = string.sub(s , pos + 1 , string.len(s));

		return preset , tonumber(exppoints);
	else
		return s , nil;
	end
end
-----------------------------------------------------------------------------------------
-- Checks if player buys only allowed actors. Gibs prohibited actors if not
-----------------------------------------------------------------------------------------
function CF_CheckForeignTroops()
	-- Comment out contents of this function to disable foreign actor kill

	local isvalid;

	if CF_ForeignCheckTimer:IsPastSimMS(250) then
		for actor in MovableMan.Actors do
			if actor.Team == CF_PlayerTeam then
				if actor.ClassName ~= "ADoor" then
					isvalid = false;

					local presetname , actorexp;
					
					for i = 1, #CF_AllowedActors[CF_PlayerFaction] do
						presetname , actorexp = CF_ParsePresetName(actor.PresetName);
					
						if presetname == CF_AllowedActors[CF_PlayerFaction][i] then
							isvalid = true;
						end
					end
					
					if not isvalid then
						actor:GibThis();
					end
				end
			end
		end -- for
		
		CF_ForeignCheckTimer:Reset();
	end--]]--
end
