-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function LoadScreen:StartActivity()
	self.MaxSavedGames = 6;
	self.ModuleName = "UnmappedLands.rte";
	self.Elements = {};
	
	self.Modes = {LOADGAME = 0 , NEWGAME = 1};
	self.CurrentMode = self.Modes.LOADGAME;
	
	self.MidX = SceneMan.Scene.Width / 2;
	self.MidY = SceneMan.Scene.Height / 2;
	self.Mid = Vector(self.MidX , self.MidY);
	
	self.LoadSlots = {};
	self.NewGameSlot = 0;

	self.ControlsEnabled = true;
	self.ControlPressed = 0;
	self.ControlNewGamePressed = 0;
	
	print("LOAD:Fill slot elements");
	
	for i = 1, self.MaxSavedGames do
		self.Elements[i] = {};
		if CF_IsFileExists(self.ModuleName , "SAVEGAME"..i..".dat") then
			local config = {};
			
			config = CF_ReadConfigFile(self.ModuleName , "SAVEGAME"..i..".dat");
			
			if config["PlayerFaction"] ~= nil then
			
				if config["PlayerFaction"] == "Ronin" then
					self.Elements[i]["Description"] = "Ronin campaign\n";
					self.Elements[i]["Preset"] = "Ronin";
				elseif config["PlayerFaction"] == "Dummy" then
					self.Elements[i]["Description"] = "Dummy campaign\n";
					self.Elements[i]["Preset"] = "Dummy";
				elseif config["PlayerFaction"] == "Coalition" then
					self.Elements[i]["Description"] = "Coalition campaign\n";
					self.Elements[i]["Preset"] = "Coalition";
				elseif config["PlayerFaction"] == "Bearforce" then
					self.Elements[i]["Description"] = "Bearforce campaign\n";
					self.Elements[i]["Preset"] = "Bearforce";
				end

				self.Elements[i]["Description"] = self.Elements[i]["Description"] ..
					"Turn #"..config["TurnNumber"].." , "..config["PlayerGold"].." oz of gold. "..
					config["Deaths"].." dead vs "..config["Kills"].." killed.";

				self.LoadSlots[i] = true;
			else
				self.Elements[i]["Description"] = "Empty\Broken slot #"..i.."\nPress FIRE to start a new campaign in this slot";
				self.Elements[i]["Preset"] = "Empty";
				
				self.LoadSlots[i] = false;
			end
		else
			self.Elements[i]["Description"] = "Empty slot #"..i.."\nPress FIRE to start a new campaign in this slot";
			self.Elements[i]["Preset"] = "Empty";

			self.LoadSlots[i] = false;
		end
	end

	print("LOAD:Init elements");
	
	self.Elements[1]["NextPlate"] = {6 , 2 , 8 , 7}; -- {L , R , U , D}
	self.Elements[2]["NextPlate"] = {1 , 3 , 8 , 7}; -- {L , R , U , D}
	self.Elements[3]["NextPlate"] = {2 , 4 , 8 , 7}; -- {L , R , U , D}
	self.Elements[4]["NextPlate"] = {3 , 5 , 8 , 7}; -- {L , R , U , D}
	self.Elements[5]["NextPlate"] = {4 , 6 , 8 , 7}; -- {L , R , U , D}
	self.Elements[6]["NextPlate"] = {5 , 1 , 8 , 7}; -- {L , R , U , D}
	
	self.Elements[self.MaxSavedGames + 1] = {};
	self.Elements[self.MaxSavedGames + 1]["Description"] = "Start New Game";
	self.Elements[self.MaxSavedGames + 1]["Preset"] = "ButtonNewCampaign";
	self.Elements[self.MaxSavedGames + 1]["NextPlate"] = {7 , 7 , 3 , 8}; -- {L , R , U , D}
	
	self.Elements[self.MaxSavedGames + 2] = {};
	self.Elements[self.MaxSavedGames + 2]["Description"] = "Exit to strategy screen";
	self.Elements[self.MaxSavedGames + 2]["Preset"] = "ButtonExit";
	self.Elements[self.MaxSavedGames + 2]["NextPlate"] = {8 , 8 , 7 , 3}; -- {L , R , U , D}

	
	self.Selection = 1;
	self.XTiles = 6; -- Plates per row
	
	self.HelpText = "Use LEFT, RIGHT, UP, DOWN to choose LOAD slot, press FIRE to select\n";

	self.ElementsPos = {};
	
	for i = 1 , self.MaxSavedGames do
		self.ElementsPos[i] = Vector(30 + (self.MidX) - (self.XTiles * 62 / 2) + ((i - 1) % self.XTiles) * 62  , 
									    self.MidY);
	end

	--self.ElementsPos[self.MaxSavedGames + 1] = self.Mid + Vector(130 , 41);	
	--self.ElementsPos[self.MaxSavedGames + 2] = self.Mid + Vector(139 , 61);

	-- self.ElementsPos[6] = self.Mid;
	
	self.ElementsPos[self.MaxSavedGames + 1] = self.Mid + Vector(0 , 48);	
	self.ElementsPos[self.MaxSavedGames + 2] = self.Mid + Vector(0 , 66);

	
	self.Plates = {};
	
	-- New game sub-menu
	self.NewGameElements = {};
	self.NewGameElements[1] = {};
	self.NewGameElements[1]["Description"] = "Start Coalition Campaign";
	self.NewGameElements[1]["Preset"] = "CoalitionBanner";
	self.NewGameElements[1]["NextPlate"] = {4 , 2 , 5 , 5}; -- {L , R , U , D}
	
	self.NewGameElements[2] = {};
	self.NewGameElements[2]["Description"] = "Start Dummy Campaign";
	self.NewGameElements[2]["Preset"] = "DummyBanner";
	self.NewGameElements[2]["NextPlate"] = {1 , 3 , 5 , 5}; -- {L , R , U , D}
	
	self.NewGameElements[3] = {};
	self.NewGameElements[3]["Description"] = "Start Ronin Campaign";
	self.NewGameElements[3]["Preset"] = "RoninBanner";
	self.NewGameElements[3]["NextPlate"] = {2 , 4 , 5 , 5}; -- {L , R , U , D}

	self.NewGameElements[4] = {};
	self.NewGameElements[4]["Description"] = "Start Bearforce Campaign";
	self.NewGameElements[4]["Preset"] = "BearforceBanner";
	self.NewGameElements[4]["NextPlate"] = {3 , 1 , 5 , 5}; -- {L , R , U , D}	

	self.NewGameElements[5] = {};
	self.NewGameElements[5]["Description"] = "Back to load game list";
	self.NewGameElements[5]["Preset"] = "ButtonBack";
	self.NewGameElements[5]["NextPlate"] = {5 , 5 , 2 , 2}; -- {L , R , U , D}

	self.NewGameSelection = 1;
	self.NewGameXTiles = 4; -- Plates per row
	self.NewGameYTiles = 1;
	
	self.NewGameHelpText = "Use MOVE LEFT and MOVE RIGHT to choose faction, press FIRE to confirm selection\n";

	self.NewGameElementsPos = {};
	
	for i = 1 , #self.NewGameElements do
		self.NewGameElementsPos[i] = Vector(260 + self.MidX - (self.XTiles * 130 / 2) + ((i - 1) % self.XTiles) * 130  , 
									    self.MidY - 48);
	end
	
	self.NewGameElementsPos[5] = self.Mid + Vector(0 , 48);
	
	self.NewGamePlates = {};
	
	--Make an invisible brain.
	self.brain = CreateActor("Brain Case");
	self.brain.Scale = 0;
	self.brain.Team = Activity.TEAM_1;
	self.brain.Pos = self.Mid;
	MovableMan:AddActor(self.brain);
	self:SetPlayerBrain(self.brain,Activity.TEAM_1);
	self:SwitchToActor(self.brain,Activity.PLAYER_1,-1);

	self.SlotBack = CreateMOSRotating("SlotBackground" , self.ModuleName);
	self.SlotBack.Pos = self.Mid;
	MovableMan:AddParticle(self.SlotBack);	

	self.FactionBack = nil;

	self.Title = CreateMOSRotating("TitleLoadGame" , self.ModuleName);
	self.Title.Pos = self.Mid + Vector(0, -70);
	MovableMan:AddParticle(self.Title);	
	
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self:EnterLoadGameMode();
	
	self.UITimer = Timer();
	self.UITimer:Reset();
	
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function LoadScreen:PauseActivity(pause)
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function LoadScreen:EndActivity()
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function LoadScreen:EnterNewGameMode()
	for i = 1, #self.Elements do
		MovableMan:RemoveParticle(self.Plates[i]);
		self.Plates[i] = nil;
	end

	self.FactionBack = CreateMOSRotating("FactionBackground" , self.ModuleName);
	self.FactionBack.Pos = self.Mid + Vector(0 , -49);
	MovableMan:AddParticle(self.FactionBack);	
	
	self.NewGameSelection = 1;
	self:RedrawAllNewGamePlates();
	
	self.CurrentMode = self.Modes.NEWGAME;
	self.GenericTimer:Reset();
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function LoadScreen:EnterLoadGameMode()
	for i = 1, #self.NewGamePlates do
		if MovableMan:IsParticle(self.NewGamePlates[i]) then
			MovableMan:RemoveParticle(self.NewGamePlates[i]);
			self.NewGamePlates[i] = nil;
		end
	end

	if MovableMan:IsParticle(self.FactionBack) then
		MovableMan:RemoveParticle(self.FactionBack);
	end
	
	self.Selection = 1;
	self.NewGameSlot = 0;
	
	self:RedrawAllPlates();
		
	self.CurrentMode = self.Modes.LOADGAME;
	self.GenericTimer:Reset();
end
-----------------------------------------------------------------------------------------
-- Redraw new campaign dialog mission plate
-----------------------------------------------------------------------------------------
function LoadScreen:RedrawNewGamePlate(platenum , isselected , ispressed)
	if MovableMan:IsParticle(self.NewGamePlates[platenum]) then
		MovableMan:RemoveParticle(self.NewGamePlates[platenum]);
		self.NewGamePlates[platenum] = nil;
	end

	local preset;

	if isselected then
		preset = self.NewGameElements[platenum]["Preset"].."MouseOver";
	else
		preset = self.NewGameElements[platenum]["Preset"].."Idle";
	end
	
	if ispressed then
		preset = self.NewGameElements[platenum]["Preset"].."Pressed";
	end	

	self.NewGamePlates[platenum] = CreateMOSRotating(preset , self.ModuleName);

	self.NewGamePlates[platenum].Pos = self.NewGameElementsPos[platenum];
	MovableMan:AddParticle(self.NewGamePlates[platenum]);	
end
-----------------------------------------------------------------------------------------
-- Redraw load menu plate
-----------------------------------------------------------------------------------------
function LoadScreen:RedrawPlate(platenum , isselected , ispressed)
	if MovableMan:IsParticle(self.Plates[platenum]) then
		MovableMan:RemoveParticle(self.Plates[platenum]);
		self.Plates[platenum] = nil;
	end

	local preset;

	if platenum >= 1 and platenum <= 6 then
		if self.Elements[platenum]["Preset"] == "Empty"  then
			if isselected then
				preset = "Slot"..platenum.."EmptyMouseOver";
			else
				preset = "Slot"..platenum.."Empty";
			end
			
			if ispressed then
				preset = "Slot"..platenum.."EmptyPressed";
			end
		else
			if isselected then
				preset = "Slot"..platenum..self.Elements[platenum]["Preset"].."LoadFrom";
			else
				preset = "Slot"..platenum..self.Elements[platenum]["Preset"].."Idle";
			end

			if ispressed then
				preset = "Slot"..platenum..self.Elements[platenum]["Preset"].."LoadFromPressed";
			end
		end
	else
		if isselected then
			preset = self.Elements[platenum]["Preset"].."MouseOver";
		else
			preset = self.Elements[platenum]["Preset"].."Idle";
		end
		
		if ispressed then
			preset = self.Elements[platenum]["Preset"].."Pressed";
		end
	end

	self.Plates[platenum] = CreateMOSRotating(preset , self.ModuleName);
	if isselected then
		self.Plates[platenum].SpriteAnimMode = 1;
	end
	
	self.Plates[platenum].Pos = self.ElementsPos[platenum];
	MovableMan:AddParticle(self.Plates[platenum]);	
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function LoadScreen:RedrawAllNewGamePlates()
	for i = 1, #self.NewGameElements do
		self:RedrawNewGamePlate(i , false , false);
	end

	self:RedrawNewGamePlate(self.NewGameSelection , true , false);
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function LoadScreen:RedrawAllPlates()
	for i = 1, #self.Elements do
		self:RedrawPlate(i , false , false);
	end

	self:RedrawPlate(self.Selection , true , false);
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function LoadScreen:MakeNewConfig(faction , slot)
	local config = {};
	
	config["PlayerFaction"] = faction;
	if faction == "Coalition" then
		config["CPU1Faction"] = "Dummy";
		config["CPU2Faction"] = "Ronin";
		config["CPU3Faction"] = "Bearforce";
	end

	if faction == "Dummy" then
		config["CPU1Faction"] = "Coalition";
		config["CPU2Faction"] = "Ronin";
		config["CPU3Faction"] = "Bearforce";
	end

	if faction == "Ronin" then
		config["CPU1Faction"] = "Coalition";
		config["CPU2Faction"] = "Dummy";
		config["CPU3Faction"] = "Bearforce";
	end

	if faction == "Bearforce" then
		config["CPU1Faction"] = "Coalition";
		config["CPU2Faction"] = "Ronin";
		config["CPU3Faction"] = "Dummy";
	end

	config["PlayerGold"] = 5000;
	config["TurnNumber"] = 1;
	config["DefaultSlot"] = slot;
	config["Kills"] = 0;
	config["Deaths"] = 0;
	config["PlayerAttackTerritory"]	= 0;
	config["PlayerDefendTerritory"]	= 0;
	config["CPU1AttackTerritory"]	= 0;
	config["CPU2AttackTerritory"]	= 0;
	config["LastMissionTerritory"] = 0;
	config["LastMissionCPUFaction"] = "Nobody";
	config["LastMissionAIBudget"] = 0;
	config["LastMissionResult"] = "None";
	config["LastMissionLootCollected"] = 0;
	config["LastMissionInitiator"] = "Nobody";
	config["LastMissionOwnerOnVictory"] = "Nobody";
	config["LastMissionOwnerOnDefeat"] = "Nobody";
	config["GoldPerMine"] = 50;
	config["BrainCost"] = 500;
	config["MineCost"] = 300;
	config["TrooperCost"] = 100;
	config["PlayerHasBrain"] = "true";
	config["StartTurnProcessing"] = "false";
	config["MaxTurnPoints"] = 5;
	config["UsedTurnPoints"] = 0;
	config["PointsPerAttack"] = 2;
	config["PointsPerDefence"] = 2;
	config["MaxMinesPerLand"] = 5;
	config["MaxTroopersPerLand"] = 5;
	config["MaxElite"] = 2;
	config["Elite1"] = "None";
	config["Elite2"] = "None";
	
	-- Welcome messages and planet configurations
	if faction == "Coalition" then
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "Get these damn aliens off our planet, Commander. Comm out.");
	end
		
	if faction == "Dummy" then
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "1001001 01001001 00100101");
	end

	if faction == "Ronin" then
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "Claim the planet in the name of the Ronin!");
	end

	if faction == "Bearforce" then
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "");
		CF_UpdateLog(config , "Acquire this planet for the Motherland, Comrade!");
	end

	config["Planet1Owner"] = "Coalition";
	config["Planet1Mines"] = 1;
	config["Planet1Troopers"] = 0;
	
	config["Planet2Owner"] = "Coalition";
	config["Planet2Mines"] = 1;
	config["Planet2Troopers"] = 0;

	config["Planet3Owner"] = "Nobody";
	config["Planet3Mines"] = 0;
	config["Planet3Troopers"] = 0;

	config["Planet4Owner"] = "Nobody";
	config["Planet4Mines"] = 0;
	config["Planet4Troopers"] = 0;

	config["Planet5Owner"] = "Dummy";
	config["Planet5Mines"] = 1;
	config["Planet5Troopers"] = 0;

	config["Planet6Owner"] = "Dummy";
	config["Planet6Mines"] = 1;
	config["Planet6Troopers"] = 0;

	config["Planet7Owner"] = "Bearforce";
	config["Planet7Mines"] = 1;
	config["Planet7Troopers"] = 0;

	config["Planet8Owner"] = "Bearforce";
	config["Planet8Mines"] = 1;
	config["Planet8Troopers"] = 0;

	config["Planet9Owner"] = "Ronin";
	config["Planet9Mines"] = 1;
	config["Planet9Troopers"] = 0;

	config["Planet10Owner"] = "Ronin";
	config["Planet10Mines"] = 1;
	config["Planet10Troopers"] = 0;

	return config;
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function LoadScreen:StartNewGame(faction , slot)
	local config = {};
	
	config = self:MakeNewConfig(faction , slot);

	if slot > 0 then
		CF_WriteConfigFile(config , self.ModuleName , "SAVEGAME"..slot..".dat");
	end
	CF_WriteConfigFile(config , self.ModuleName , "CURRENT.dat");
	ActivityMan:EndActivity();
	ActivityMan:StartActivity("GAScripted" , "StrategyScreen");
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function LoadScreen:LoadGame(slot)
	local config;
	
	config = CF_ReadConfigFile(self.ModuleName , "SAVEGAME"..slot..".dat");
	
	CF_WriteConfigFile(config , self.ModuleName , "CURRENT.dat");
	ActivityMan:EndActivity();
	ActivityMan:StartActivity("GAScripted" , "StrategyScreen");
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function LoadScreen:UpdateActivity()
	--Move the cursor.
	local cont = self.brain:GetController();

	if self.CurrentMode == self.Modes.LOADGAME then
		FrameMan:SetScreenText(self.HelpText..self.Elements[self.Selection]["Description"], Activity.PLAYER_1, 0, 1, false);
		-- Add delay to avoid triggering multiple button hits when player holds key for too long
		if self.GenericTimer:IsPastSimMS(350) then
			if self.ControlsEnabled then
				if cont:IsState(Controller.PRESS_LEFT) then
					self:RedrawPlate(self.Selection , false , false);
					self.Selection = self.Elements[self.Selection]["NextPlate"][1];
					self:RedrawPlate(self.Selection , true , false);
				end

				if cont:IsState(Controller.PRESS_RIGHT) then
					self:RedrawPlate(self.Selection , false , false);
					self.Selection = self.Elements[self.Selection]["NextPlate"][2];
					self:RedrawPlate(self.Selection , true , false);
				end

				if cont:IsState(Controller.PRESS_UP) then
					self:RedrawPlate(self.Selection , false , false);
					self.Selection = self.Elements[self.Selection]["NextPlate"][3];
					self:RedrawPlate(self.Selection , true , false);
				end

				if cont:IsState(Controller.PRESS_DOWN) then
					self:RedrawPlate(self.Selection , false , false);
					self.Selection = self.Elements[self.Selection]["NextPlate"][4];
					self:RedrawPlate(self.Selection , true , false);
				end
				

				--If fire has been pushed, start mission.
				if cont:IsState(Controller.WEAPON_FIRE) then
					print (self.Selection);
					self.ControlPressed = self.Selection;
					self.ControlsEnabled = false;
					self.UITimer:Reset();
					self:RedrawPlate(self.Selection , false , true);
					self.GenericTimer:Reset();
				end
			end
		end

		if self.ControlPressed > 0 then
			if self.UITimer:IsPastSimMS(350) then
				self:RedrawPlate(self.ControlPressed , true , false);
				--ActivityMan:StartActivity("GAScripted" , self.Elements[self.Selection]["Activity"]);
				if self.Selection >= 1 and self.Selection <= self.MaxSavedGames then
					if self.LoadSlots[self.Selection] then
						self:LoadGame(self.Selection);
					else
						self.NewGameSlot = self.Selection;
						self:EnterNewGameMode();
					end
				end

				if self.Selection == self.MaxSavedGames + 2 then
					ActivityMan:EndActivity();
					ActivityMan:StartActivity("GAScripted" , "Unmapped Lands");
				end
				
				if self.Selection == self.MaxSavedGames + 1 then
					self:EnterNewGameMode();
				end

				
				self.ControlsEnabled = true;
				self.ControlPressed = 0;				
			end
		end
		
	end

	
	if self.CurrentMode == self.Modes.NEWGAME then
		FrameMan:SetScreenText(self.NewGameHelpText..self.NewGameElements[self.NewGameSelection]["Description"], Activity.PLAYER_1, 0, 1, false);

		if self.GenericTimer:IsPastSimMS(350) then
			if self.ControlsEnabled then
				if cont:IsState(Controller.PRESS_LEFT) then
					self:RedrawNewGamePlate(self.NewGameSelection , false , false);
					self.NewGameSelection = self.NewGameElements[self.NewGameSelection]["NextPlate"][1];
					self:RedrawNewGamePlate(self.NewGameSelection , true , false);
				end

				if cont:IsState(Controller.PRESS_RIGHT) then
					self:RedrawNewGamePlate(self.NewGameSelection , false , false);
					self.NewGameSelection = self.NewGameElements[self.NewGameSelection]["NextPlate"][2];
					self:RedrawNewGamePlate(self.NewGameSelection , true , false);
				end

				if cont:IsState(Controller.PRESS_UP) then
					self:RedrawNewGamePlate(self.NewGameSelection , false , false);
					self.NewGameSelection = self.NewGameElements[self.NewGameSelection]["NextPlate"][3];
					self:RedrawNewGamePlate(self.NewGameSelection , true , false);
				end

				if cont:IsState(Controller.PRESS_DOWN) then
					self:RedrawNewGamePlate(self.NewGameSelection , false , false);
					self.NewGameSelection = self.NewGameElements[self.NewGameSelection]["NextPlate"][4];
					self:RedrawNewGamePlate(self.NewGameSelection , true , false);
				end

				--If fire has been pushed, start mission.
				if cont:IsState(Controller.WEAPON_FIRE) then
					self.ControlNewGamePressed = self.NewGameSelection;
					self.ControlsEnabled = false;
					self.UITimer:Reset();
					self:RedrawNewGamePlate(self.NewGameSelection , false , true);
					self.GenericTimer:Reset();
				end
			end
		end

		if self.ControlNewGamePressed > 0 then
			if self.UITimer:IsPastSimMS(350) then
				self:RedrawNewGamePlate(self.ControlNewGamePressed , true , false);

				if self.NewGameSelection == 1 then
					self:StartNewGame("Coalition" , self.NewGameSlot);
				end

				if self.NewGameSelection == 2 then
					self:StartNewGame("Dummy" , self.NewGameSlot);
				end

				if self.NewGameSelection == 3 then
					self:StartNewGame("Ronin" , self.NewGameSlot);
				end
								
				if self.NewGameSelection == 4 then
					self:StartNewGame("Bearforce" , self.NewGameSlot);
				end

				if self.NewGameSelection == 5 then
					self:EnterLoadGameMode();
				end
				
				self.ControlsEnabled = true;
				self.ControlNewGamePressed = 0;				
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Thats all folks!!!
-----------------------------------------------------------------------------------------