-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Attack02:StartActivity()
	print("START! -- Attack02:StartActivity()!");

	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	--self.ConfigName = "Attack02.dat"; -- Debug
	self.ConfigName = "current.dat";
	self.ModuleName = "UnmappedLands.rte";
	
	self.Config = CF_ReadConfigFile(self.ModuleName , self.ConfigName);
	CF_InitFactions();
	CF_InitMission(self.Config);
	-- end of generic part	
	---------------------------------------------------------------------

	self.AIDrop = SceneMan.Scene:GetArea("AIDrop");
	self.AIDrop2 = SceneMan.Scene:GetArea("AIDrop2");
	self.DistributionPoint = SceneMan.Scene:GetArea("DistributionPoint");
	self.Bombing = SceneMan.Scene:GetArea("Bombing");
	
	self.braindead = {};
	self.AssignedBrains = {};
	
	for player = 0, self.PlayerCount - 1 do
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CF_SpawnBrain(CF_PlayerTeam , nil , CF_PlayerFaction , Actor.AIMODE_SENTRY);
			--brain:AddInventoryItem(CreateHeldDevice("Nanite Inhibitor" , self.ModuleName)); -- DEBUG
			--brain:AddInventoryItem(CreateHeldDevice("Nanite Inhibitor" , self.ModuleName)); -- DEBUG
			--brain:AddInventoryItem(CreateHeldDevice("Nanite Inhibitor" , self.ModuleName)); -- DEBUG
			--brain:AddInventoryItem(CreateHeldDevice("Nanite Inhibitor" , self.ModuleName)); -- DEBUG
			-- brain.Pos = Vector(192 , 264); -- Debug
			brain.Pos = Vector(1500 + player * 30 , 930); -- Gameplay
			brain.AIMode = Actor.AIMODE_SENTRY;
			self.AssignedBrains[player] = brain;

            MovableMan:AddActor(brain);
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
			self:SwitchToActor(brain, player, CF_PlayerTeam);
        end
    end

	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	CF_ReplaceAddedActors(self.Config);
	CF_ArrangeEliteActors(self.Config);
	-- end of generic part	
	---------------------------------------------------------------------
	

    self.FightPhase = { NOFIGHT = 0 , COLLECT = 1};
    self.CurrentFightPhase = self.FightPhase.NOFIGHT;
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.BombardTimer = Timer();
	self.BombardTimer:Reset();
	
	self.DropshipSpawnInterval = 20000;
	self.DropshipSpawnTimer = Timer();
	self.DropshipSpawnTimer:Reset();

	self.TroopCount = {};
	self.LastAssignPoint = 1;

	-- Clone generators
	self.CloningVatsDesyncTimer = Timer();
	self.CloningVatsDesyncTimer:Reset();
	self.CloningEnabled = false;	
	self.CloningVats = {};
	self.CloningVatsCoords = {};
	
	self.CloningVatsCoords[1] = Vector(624, 1308) + Vector(0 , 12);
	self.CloningVatsCoords[2] = Vector(1200, 1260) + Vector(0 , 12);
	self.CloningVatsCoords[3] = Vector(144, 1788) + Vector(0 , 12);
	self.CloningVatsCoords[4] = Vector(1872, 1788) + Vector(0 , 12);

   	for i = 1 , 4 do
		self.CloningVats[i] = CreateAEmitter("Zombie Vat" , self.ModuleName);
		self.CloningVats[i].Pos = self.CloningVatsCoords[i];
		self.CloningVats[i].Team = CF_RogueTeam;
		self.CloningVats[i]:EnableEmission(false);
		MovableMan:AddParticle(self.CloningVats[i]);
	end

	--Bomb Makers
	self.Assemblers = {};
	self.AssemblerCoords = {};

	self.AssemblerCoords[1] = self.CloningVatsCoords[1] + Vector(48 , -8);
	self.AssemblerCoords[2] = self.CloningVatsCoords[2] + Vector(48 , -8);
	self.AssemblerCoords[3] = self.CloningVatsCoords[3] + Vector(48 , -8);
	self.AssemblerCoords[4] = self.CloningVatsCoords[4] + Vector(-60 , -8);
	
  	for i = 1 , 4 do
		self.Assemblers[i] = CreateAEmitter("Nano Assembler" , self.ModuleName);
		self.Assemblers[i].Pos = self.AssemblerCoords[i];
		self.Assemblers[i].Team = CF_RogueTeam;
		self.Assemblers[i]:EnableEmission(false);
		MovableMan:AddParticle(self.Assemblers[i]);
	end
	
	self.DisableZones = {};
	for i = 1, 4 do
		self.DisableZones[i] = SceneMan.Scene:GetArea("Disable"..i);
	end

	-- Destination points
	local area;
	local actor, price;
	self.DestPoints = {}; 
	
	for i = 1 , 8 do
		area = SceneMan.Scene:GetArea("Dest"..i);
		self.DestPoints[i] = area:GetCenterPoint();
		
		if math.random() < 0.45 then
			actor , price = CF_SpawnRandomInfantry(CF_CPUTeam , nil , CF_CPUFaction , Actor.AIMODE_BRAINHUNT);
			actor.Pos = self.DestPoints[i];
			
			MovableMan:AddActor(actor);
		else
			actor = CreateAHuman("Zombie Medium");
			actor.Pos = self.DestPoints[i];
			actor.AIMode = Actor.AIMODE_BRAINHUNT;
			actor.Team = CF_RogueTeam;
			actor:AddInventoryItem(CreateHDFirearm("Auto Shotgun" , "Coalition.rte"));

			MovableMan:AddActor(actor);
		end
	end
	
	self.ScreenCount = 4;
	self.ScreensPos = {};
	self.Screens = {};
	
	self.ScreensPos[1] = Vector(912 , 996);
	self.ScreensPos[2] = Vector(1488 , 1140);
	self.ScreensPos[3] = Vector(816 , 1668);
	self.ScreensPos[4] = Vector(1200 , 1668);
	
	for i = 1, self.ScreenCount do
		self.Screens[i] = CreateAEmitter("Static Screen" , self.ModuleName);
		self.Screens[i].Pos = self.ScreensPos[i];
		self.Screens[i]:EnableEmission(true);
		MovableMan:AddParticle(self.Screens[i]);
	end
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function Attack02:PauseActivity(pause)
    print("PAUSE! -- Attack02:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function Attack02:EndActivity()
    print("END! -- Attack02:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack02:CountStats()
	-- Count troops
	self.TroopCount[CF_PlayerTeam] = 0;
	self.TroopCount[CF_RogueTeam] = 0;
	self.TroopCount[CF_CPUTeam] = 0;
	
	for actor in MovableMan.Actors do
		self.TroopCount[actor.Team] = self.TroopCount[actor.Team] + 1;
		
		if actor.Team == CF_PlayerTeam then
			if actor:HasObject("Nanite Inhibitor") then
				self:AddObjectivePoint("Drop inhibitors under vats", actor.AboveHUDPos, CF_PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end
	
	--print("Player "..self.TroopCount[CF_PlayerTeam]);
	--print("Rogue "..self.TroopCount[CF_RogueTeam]);
	--print("CPU "..self.TroopCount[CF_CPUTeam]);
end
-----------------------------------------------------------------------------------------
-- Turn cloning vats on and off to prevent MOID limit hit
-----------------------------------------------------------------------------------------
function Attack02:DoCloneBreedingControl()

	if MovableMan:GetMOIDCount() > CF_MOIDLimit or self.TroopCount[CF_RogueTeam] > 6 then
		-- Disable cloning if we hit MOID limit
		self.CloningEnabled = false;
	else
		if self.CloningEnabled == false then
			-- Enable cloning if we below MOID limit
			-- and don't have troops limit
			self.CloningEnabled = true;
			-- Reset startup timer to start vats asynchronous mode
			self.CloningVatsDesyncTimer:Reset();
		end
	end

	for i = 1 , #self.CloningVats do
		if  MovableMan:IsParticle(self.CloningVats[i]) then
			if self.CloningEnabled == false then
				self.CloningVats[i]:EnableEmission(false);
			else
				-- Every vat starts with 2.5 sec delay
				if self.CloningVatsDesyncTimer:IsPastSimMS(i * 2500) then
					if not self.CloningVats[i]:IsEmitting() then
						self.CloningVats[i]:EnableEmission(true);
					end
				end
			end
		else
			self.CloningVats[i] = nil;
		end

		if  MovableMan:IsParticle(self.Assemblers[i]) then
			if self.CloningEnabled == false then
				self.Assemblers[i]:EnableEmission(false);
			else
				-- Every vat starts with 2.5 sec delay
				if self.CloningVatsDesyncTimer:IsPastSimMS(i * 2500) then
					if not self.Assemblers[i]:IsEmitting() then
						self.Assemblers[i]:EnableEmission(true);
					end
				end
			end
		else
			self.Assemblers[i] = nil;
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack02:DoBombardment()
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval * 0.4) and not self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval * 0.80) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("INCOMING!!!", player, 500, 5000, true);
		end
		
		self:AddObjectivePoint("INCOMING!!!", Vector(500 , 0), CF_PlayerTeam, GameActivity.ARROWUP);
		self:AddObjectivePoint("INCOMING!!!", Vector(1000 , 0), CF_PlayerTeam, GameActivity.ARROWUP);
		self:AddObjectivePoint("INCOMING!!!", Vector(1500 , 0), CF_PlayerTeam, GameActivity.ARROWUP);
	end
	
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval * 0.80) and not self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval * 0.98) then
		if self.BombardTimer:IsPastSimMS(400) then
			local shell;
			
			shell = CreateMOSRotating("Coalition Solid Uber Shell" , self.ModuleName);
			shell.Pos = Vector(self.Bombing:GetRandomPoint().X - 250 , -50);
			shell.Vel = Vector(7 , 7);
			MovableMan:AddParticle(shell);
		
			self.BombardTimer:Reset();
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack02:DistributeTroops()
	-- Assign falling troops to specific firing points
	for actor in MovableMan.Actors do
		if (actor.Team == CF_CPUTeam or actor.Team == CF_RogueTeam) and actor.AIMode == Actor.AIMODE_SENTRY then
			if self.DistributionPoint:IsInside(actor.Pos) then
				actor.AIMode = Actor.AIMODE_GOTO;
				actor:ClearAIWaypoints();
				actor:AddAISceneWaypoint(self.DestPoints[self.LastAssignPoint]);

				self.LastAssignPoint = self.LastAssignPoint + 1;
				if self.LastAssignPoint > 8 then
					self.LastAssignPoint = 1;
				end
			end -- if 
		end -- if
	end
end
-----------------------------------------------------------------------------------------
-- Spawn dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function Attack02:SpawnDropship()
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) then
		if self.TroopCount[CF_CPUTeam] < 6 then
			if MovableMan:GetMOIDCount() < CF_MOIDLimit - 30 then
				local ship = nil;
				local actor = nil;
				local price = 0;
				local totalprice = 0;
				local p;
				local landpos;
				local spawnaa; -- Flags if we need to spawn Anti Aircraft troops
				
				for j = 1 , 2 do
					-- Select landing zone
					if j == 1 then
						landpos = Vector(self.AIDrop:GetRandomPoint().X , -30 + math.random(60));
					else
						landpos = Vector(self.AIDrop2:GetRandomPoint().X , -30 + math.random(60));
					end
				
					ship , price = CF_SpawnDropship(CF_CPUTeam , landpos , CF_CPUFaction);
					totalprice = totalprice + price;
					
					local aimode;
					
					aimode = Actor.AIMODE_SENTRY;
					
					for i = 1, 2 do
						-- Spawn armor or regular troopers depending on turn number to increase difficulty
						if math.random(100) < 10 then
							-- Give single dreadnought as dummy armor or two assalut troopers with shields
							-- to any other faction
							if CF_CPUFaction == CF_Factions.DUMMY then
								actor , price = CF_SpawnArmor(CF_CPUTeam , nil , CF_CPUFaction , Actor.AIMODE_SENTRY);
								totalprice = totalprice + price;
								
							else
								actor , price = CF_SpawnArmor(CF_CPUTeam , nil , CF_CPUFaction , Actor.AIMODE_SENTRY);
								totalprice = totalprice + price;

								actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"));
								
								if math.random() < 0.20 then
									actor:AddInventoryItem(CreateHeldDevice("Nanite Inhibitor" , self.ModuleName));
								end
							end
						else
							actor , price = CF_SpawnRandomInfantry(CF_CPUTeam , nil , CF_CPUFaction , Actor.AIMODE_SENTRY);
							totalprice = totalprice + price;

							actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"));

							if math.random() < 0.30 then
								actor:AddInventoryItem(CreateHeldDevice("Nanite Inhibitor" , self.ModuleName));
							end
						end
						
						ship:AddInventoryItem(actor);
					end

					MovableMan:AddActor(ship);
				end
			end
			self.DropshipSpawnTimer:Reset();
		end
	end
end
-----------------------------------------------------------------------------------------
-- Phase NOFIGHT
-----------------------------------------------------------------------------------------
function Attack02:PhaseNoFight()
	if not self.GenericTimer:IsPastSimMS(500) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("COLLECT NANITE INHIBITORS FROM INCOMING TROOPS!", player, 500, 5000, true);
		end
	end

	if self.GenericTimer:IsPastSimMS(5000) and not self.GenericTimer:IsPastSimMS(5500) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("USE INHIBITORS TO DISABLE VATS AND NANOASSEMBLERS", player, 500, 5000, true);
		end
	end
	
	for player = 0, self.PlayerCount - 1 do
		if MovableMan:IsActor(self.AssignedBrains[player]) then
			if not self.GenericTimer:IsPastSimMS(5000) then
				self:AddObjectivePoint("Protect Commander", self.AssignedBrains[player].AboveHUDPos, CF_PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end
	
	if self.GenericTimer:IsPastSimMS(15000) then
		self:AdvanceToCollect();
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack02:AdvanceToCollect()
	self.CurrentFightPhase = self.FightPhase.COLLECT;
end
-----------------------------------------------------------------------------------------
-- Phase 
-----------------------------------------------------------------------------------------
function Attack02:PhaseCollect()
	for item in MovableMan.Items do
		if item.PresetName == "Nanite Inhibitor" then
			self:AddObjectivePoint("Collect!", item.Pos + Vector(0 , -20), CF_PlayerTeam, GameActivity.ARROWDOWN);
			
			for i = 1, 4 do
				if self.DisableZones[i]:IsInside(item.Pos) then
					local togib;
					
					togib = false;
					--togib = true;
				
					if MovableMan:IsParticle(self.CloningVats[i]) then
						local deadvat;
						
						MovableMan:RemoveParticle(self.CloningVats[i]);
						self.CloningVats[i] = nil;
					
						deadvat = CreateAEmitter("Disabled Zombie Vat" , self.ModuleName);
						deadvat.Pos = self.CloningVatsCoords[i];
						deadvat.Team = CF_RogueTeam;
						deadvat:EnableEmission(false);
						MovableMan:AddParticle(deadvat);
						
						togib = true;
					end
					
					if MovableMan:IsParticle(self.Assemblers[i]) then
						self.Assemblers[i]:EnableEmission(false);
						self.Assemblers[i] = nil;
						
						togib = true;
					end
					
					if togib then
						local mosr = ToMOSRotating(item);
						mosr:GibThis();
					end
					
					break;
				end
			end
		end
	end

	self:SpawnDropship();
	self:DoBombardment();
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Attack02:UpdateActivity()
   	self:ClearObjectivePoints();
	
	self:CountStats();
	self:DoCloneBreedingControl();
	self:DistributeTroops();

	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight();
	elseif self.CurrentFightPhase == self.FightPhase.COLLECT then
		self:PhaseCollect();
	end	
	
	local livevats = 0;
	
	for i = 1, 4 do
		if MovableMan:IsParticle(self.CloningVats[i]) then
			livevats = livevats + 1;
		end
	end
	
	if livevats == 0 then
		if CF_Activity.ActivityState ~= Activity.OVER then
			---------------------------------------------------------------------
			-- Mission framework generic part. Must present in every mission!
			CF_CommitVictory(self.Config , self.ModuleName , self.ConfigName);
			-- end of generic part
			---------------------------------------------------------------------
			self.WinnerTeam = CF_PlayerTeam;
			ActivityMan:EndActivity();
		end
	end
	
	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	CF_ReturnOnMissionEnd();
	CF_CheckForeignTroops();
	-- end of generic part
	---------------------------------------------------------------------
	
	self:DoBrainSelection();
	
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Attack02:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
	
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					self.braindead[player] = true;
					
					if not MovableMan:GetClosestBrainActor(team) then
						if CF_Activity.ActivityState ~= Activity.OVER then
							---------------------------------------------------------------------
							-- Mission framework generic part. Must present in every mission!
							CF_CommitDefeat(self.Config , self.ModuleName , self.ConfigName);
							-- end of generic part
							---------------------------------------------------------------------
							self.WinnerTeam = self:OtherTeam(team);
							ActivityMan:EndActivity();
						end
					end
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end --if
end
-----------------------------------------------------------------------------------------
-- Enter orbit, check winning conditions
-----------------------------------------------------------------------------------------
function Attack02:CraftEnteredOrbit()
	print (CF_BrainPresets[CF_PlayerFaction]);
	if self.OrbitedCraft:HasObject(CF_BrainPresets[CF_PlayerFaction]) then
		if CF_Activity.ActivityState ~= Activity.OVER then
			---------------------------------------------------------------------
			-- Mission framework generic part. Must present in every mission!
			CF_CommitRetreat(self.Config , self.ModuleName , self.ConfigName);
			-- end of generic part
			---------------------------------------------------------------------
			self.WinnerTeam = CF_CPUTeam;
			ActivityMan:EndActivity();
		end
	end
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































