-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function StrategyScreen:StartActivity()
	self.ModuleName = "UnmappedLands.rte";

	self.Factions = {COALITION = 1 , DUMMY = 2 , RONIN = 3 , NOBODY = 4 , BEARFORCE = 5};
	self.Intentions = {NONE = 0 , ATTACK = 1 , DEFEND = 2};

   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.StartLoadScreen = false;
	self.NullState = false;
	self.StartSaveScreen = false;

	self.GS = {}; -- Gamestate table
	self.Map = {};
	for i = 1, 10 do
		self.Map[i] = {};
	end

	self.PlayerFaction = self.Factions.NOBODY;
	self.CPU1Faction = self.Factions.NOBODY;
	self.CPU2Faction = self.Factions.NOBODY;
	self.CPU3Faction = self.Factions.NOBODY;

	self.CPUFaction = {};
	self.CPUFaction[1] = self.Factions.NOBODY;
	self.CPUFaction[2] = self.Factions.NOBODY;
	self.CPUFaction[3] = self.Factions.NOBODY;

	self.StrPlayerFaction = self:FactionNumToStr(self.Factions.NOBODY);
	self.StrCPU1Faction = self:FactionNumToStr(self.Factions.NOBODY);
	self.StrCPU2Faction = self:FactionNumToStr(self.Factions.NOBODY);
	self.StrCPU3Faction = self:FactionNumToStr(self.Factions.NOBODY);

	self.StrCPUFaction = {};
	self.StrCPUFaction[1] = self:FactionNumToStr(self.Factions.NOBODY);
	self.StrCPUFaction[2] = self:FactionNumToStr(self.Factions.NOBODY);
	self.StrCPUFaction[3] = self:FactionNumToStr(self.Factions.NOBODY);

	self.CPUAttackTerritory = {};
	self.CPUAttackTerritory[1] = 0;
	self.CPUAttackTerritory[2] = 0;
	self.CPUAttackTerritory[3] = 0;

	self.PlayerIntention = self.Intentions.NONE;
	self.PlayerIntentionTerritory = 0;
	self.StartTurnProcessing = false;
	self.MissionActivityToLaunch = "";

	self.ControlsEnabled = true;
	self.ControlPressed = 0;

	self.InfoMode = 0;
	
	self.LogLinesToShow	= 4;
	
	if not CF_IsFileExists(self.ModuleName , "CURRENT.dat") then
		-- print("Nonexistent File");
		self.StartLoadScreen = true;
		self.NullState = true;
		return;
	end

	self:LoadGameState();

	self.Els = {};
	self.Els[1] = {};
	self.Els[1]["Description"] = "Territory #1\n";
	self.Els[1]["Name"] = "Territory #1";
	self.Els[1]["AttackActivity"] = "Attack01";
	self.Els[1]["NextPlate"] = {11 , 10 , 2 , 2}; -- {L , R , U , D}
	self.Els[1]["IconPos"] = {Vector(-67, -13) , Vector(-75 , 7) , Vector (-46 , 17)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[1]["NearLands"] = {2 , 3 , 10};

	self.Els[2] = {};
	self.Els[2]["Description"] = "Territory #2\n";
	self.Els[2]["Name"] = "Territory #2";
	self.Els[2]["AttackActivity"] = "Attack02";
	self.Els[2]["NextPlate"] = {13 , 3 , 1 , 1}; -- {L , R , U , D}
	self.Els[2]["IconPos"] = {Vector(-14, -20) , Vector(-24 , 0) , Vector (0 , 5)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[2]["NearLands"] = {3 , 8 , 1};

	self.Els[3] = {};
	self.Els[3]["Description"] = "Territory #3\n";
	self.Els[3]["Name"] = "Territory #3";
	self.Els[3]["AttackActivity"] = "Attack03";
	self.Els[3]["NextPlate"] = {2 , 4 , 1 , 1}; -- {L , R , U , D}
	self.Els[3]["IconPos"] = {Vector(4, 10) , Vector(-4 , 30) , Vector (11 , 35)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[3]["NearLands"] = {1 , 2 , 4 , 5 , 6};

	self.Els[4] = {};
	self.Els[4]["Description"] = "Territory #4\n";
	self.Els[4]["Name"] = "Territory #4";
	self.Els[4]["AttackActivity"] = "Attack04";
	self.Els[4]["NextPlate"] = {3 , 9 , 1 , 5}; -- {L , R , U , D}
	self.Els[4]["IconPos"] = {Vector(14, -5) , Vector(5 , 15) , Vector (21 , 20)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[4]["NearLands"] = {3 , 9 , 5 , 6};

	
	self.Els[5] = {};
	self.Els[5]["Description"] = "Territory #5\n";
	self.Els[5]["Name"] = "Territory #5";
	self.Els[5]["AttackActivity"] = "Attack01";
	self.Els[5]["NextPlate"] = {3 , 7 , 4 , 6}; -- {L , R , U , D}
	self.Els[5]["IconPos"] = {Vector(-22, 0) , Vector(16 , -9) , Vector (34 , 0)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[5]["NearLands"] = {3 , 4 , 6 , 7 , 9};

	
	self.Els[6] = {};
	self.Els[6]["Description"] = "Territory #6\n";
	self.Els[6]["Name"] = "Territory #6";
	self.Els[6]["AttackActivity"] = "Attack02";
	self.Els[6]["NextPlate"] = {2 , 7 , 5 , 4}; -- {L , R , U , D}
	self.Els[6]["IconPos"] = {Vector(-24, 10) , Vector(15 , 0) , Vector (6 , 35)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[6]["NearLands"] = {3 , 5 , 7};

	
	self.Els[7] = {};
	self.Els[7]["Description"] = "Territory #7\n";
	self.Els[7]["Name"] = "Territory #7";
	self.Els[7]["AttackActivity"] = "Attack03";
	self.Els[7]["NextPlate"] = {5 , 8 , 9 , 9}; -- {L , R , U , D}
	self.Els[7]["IconPos"] = {Vector(32, -48) , Vector(21 , -28) , Vector (33 , -2)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[7]["NearLands"] = {4 , 5 , 6 , 9 , 8};

	
	self.Els[8] = {};
	self.Els[8]["Description"] = "Territory #8\n";
	self.Els[8]["Name"] = "Territory #8";
	self.Els[8]["AttackActivity"] = "Attack04";
	self.Els[8]["NextPlate"] = {7 , 12 , 10 , 10}; -- {L , R , U , D}
	self.Els[8]["IconPos"] = {Vector(62, 0) , Vector(52 , 20) , Vector (74 , -15)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[8]["NearLands"] = {2 , 7 , 9 , 10};

	
	self.Els[9] = {};
	self.Els[9]["Description"] = "Territory #9\n";
	self.Els[9]["Name"] = "Territory #9";
	self.Els[9]["AttackActivity"] = "Attack01";
	self.Els[9]["NextPlate"] = {4 , 10 , 8 , 7}; -- {L , R , U , D}
	self.Els[9]["IconPos"] = {Vector(0, 10) , Vector(-9 , 30) , Vector (11 , 35)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[9]["NearLands"] = {4 , 5 , 7 , 8 , 10};

	self.Els[10] = {};
	self.Els[10]["Description"] = "Territory #10\n";
	self.Els[10]["Name"] = "Territory #10";
	self.Els[10]["AttackActivity"] = "Attack02";
	self.Els[10]["NextPlate"] = {9 , 11 , 8 , 8}; -- {L , R , U , D}
	self.Els[10]["IconPos"] = {Vector(15, -15) , Vector(5 , 6) , Vector (26 , 11)} -- {FactionIconOffset , MineOconOffset , TrooperIconOfsset}
	self.Els[10]["NearLands"] = {9 , 8 , 1};


	self.Els[11] = {};
	self.Els[11]["Description"] = "NEXT TURN\n";
	self.Els[11]["Preset"] = "ButtonNextTurn";
	self.Els[11]["NextPlate"] = {10 , 1 , 16 , 14}; -- {L , R , U , D}

	self.Els[12] = {};
	self.Els[12]["Description"] = "Save Game\n";
	self.Els[12]["Preset"] = "ButtonSave";
	self.Els[12]["NextPlate"] = {8 , 13 , 15 , 16}; -- {L , R , U , D}

	self.Els[13] = {};
	self.Els[13]["Description"] = "Load Game\n";
	self.Els[13]["Preset"] = "ButtonLoad";
	self.Els[13]["NextPlate"] = {12 , 4 , 15 , 16}; -- {L , R , U , D}

	self.Els[14] = {};
	self.Els[14]["Description"] = "Build mine\n";
	self.Els[14]["Preset"] = "ButtonPutMine";
	self.Els[14]["NextPlate"] = {10 , 1 , 11 , 15}; -- {L , R , U , D}

	self.Els[15] = {};
	self.Els[15]["Description"] = "Reinforce garrison\n";
	self.Els[15]["Preset"] = "ButtonPutTrooper";
	self.Els[15]["NextPlate"] = {10 , 1 , 14 , 13}; -- {L , R , U , D}

	self.Els[16] = {};
	self.Els[16]["Description"] = "Show log\n";
	self.Els[16]["Preset"] = "InfoButton";
	self.Els[16]["NextPlate"] = {10 , 1 , 12 , 11}; -- {L , R , U , D}
	
	self.Selection = 1;

	self.MidX = SceneMan.Scene.Width / 2;
	self.MidY = SceneMan.Scene.Height / 2;
	self.Mid = Vector(self.MidX , self.MidY);


	self.HelpText = "Use LEFT, RIGHT, UP, DOWN to choose, press FIRE to select\n";

	self.PlanetMid = self.Mid + Vector(-75 , 0);

	self.ElsPos = {};
	-- Manually set planet piece positions
	self.ElsPos[1] = self.PlanetMid + Vector(-111,-118);
	self.ElsPos[2] = self.PlanetMid + Vector(-167 , -6);
	self.ElsPos[3] = self.PlanetMid + Vector(-100 , -17);
	self.ElsPos[4] = self.PlanetMid + Vector(3,-41);
	self.ElsPos[5] = self.PlanetMid + Vector(35,59);
	self.ElsPos[6] = self.PlanetMid + Vector(29,129);
	self.ElsPos[7] = self.PlanetMid + Vector(101,103);
	self.ElsPos[8] = self.PlanetMid + Vector(136,89);
	self.ElsPos[9] = self.PlanetMid + Vector(107,-41);
	self.ElsPos[10] = self.PlanetMid + Vector(150,-86);

	self.ElsPos[11] = self.Mid + Vector(320,-17);
	self.ElsPos[12] = self.Mid + Vector(296,53);
	self.ElsPos[13] = self.Mid + Vector(333,53);
	self.ElsPos[14] = self.Mid + Vector(333,2);
	self.ElsPos[15] = self.Mid + Vector(333,21);
	self.ElsPos[16] = self.Mid + Vector(294,-35);

	self.ActionPointsBackDrop = CreateMOSRotating("ActionPointsBackDrop" , "UnmappedLands.rte");
	self.ActionPointsBackDrop.Pos = self.PlanetMid + Vector(389 , -53);
	self.ActionPointsBackDrop.SpriteAnimMode = 1;
	MovableMan:AddParticle(self.ActionPointsBackDrop);
	
	self.UnusedPlanet = CreateMOSRotating("PlanetUnused" , "UnmappedLands.rte");
	self.UnusedPlanet.Pos = self.PlanetMid;
	MovableMan:AddParticle(self.UnusedPlanet);

	self:RefreshGlow();

	self.Plates = {};
	self.FactionIcons = {};
	self.MineIcons = {};
	self.TrooperIcons = {};

	self.InfoPane = {};
	self.MineDigit = {};
	self.TrooperDigit = {};
	self.TurretDigit = {};
	
	self.TurnPointPlate = nil;

	self.Selection = 1;
	self:RedrawAllPlates();
	self:RedrawTurnPoints();

	self:RemakeNextTurnPlate(11 , self.PlayerIntention);
	self:RedrawPlate(11 , false , false , 0);

	--Make an invisible brain.
	self.brain = CreateActor("Brain Case");
	self.brain.Scale = 0;
	self.brain.Team = Activity.TEAM_1;
	self.brain.Pos = Vector(SceneMan.Scene.Width / 2,SceneMan.Scene.Height / 2);
	MovableMan:AddActor(self.brain);
	self:SetPlayerBrain(self.brain,Activity.TEAM_1);
	self:SwitchToActor(self.brain,Activity.PLAYER_1,-1);

	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.RefreshGlowTimer = Timer();
	self.RefreshGlowTimer:Reset();

	self.UITimer = Timer();
	self.UITimer:Reset();

	self.HelpTimer = Timer();
	self.HelpTimer:Reset();

	self.TurnProcessingDelayTimer = Timer();

	if self.StartTurnProcessing then
		self.ControlsEnabled = false;
	end
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function StrategyScreen:PauseActivity(pause)
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function StrategyScreen:EndActivity()
end
-----------------------------------------------------------------------------------------
-- Refresh planet's glow as it disappears over time due to MOSParticle unknown nature
-----------------------------------------------------------------------------------------
function StrategyScreen:RefreshGlow()
	print ("RefreshGlow");
	--if MovableMan:IsParticle(self.PlanetGlow) then
	--	MovableMan:RemoveParticle(self.PlanetGlow);
	--	self.PlanetGlow = nil;
	--end

	self.PlanetGlow = CreateMOSParticle("PlanetGlow" , "UnmappedLands.rte");
	self.PlanetGlow.Pos = self.PlanetMid + Vector(3 , 2);
	MovableMan:AddParticle(self.PlanetGlow);
end
-----------------------------------------------------------------------------------------
-- Redraw mission plate
-----------------------------------------------------------------------------------------
function StrategyScreen:RedrawPlanetPlate(platenum , isselected , ispressed , elevation)
	print ("RedrawPlanetPlate");
	-- print ("Redraw Plate "..platenum);

	if MovableMan:IsParticle(self.Plates[platenum]) then
		MovableMan:RemoveParticle(self.Plates[platenum]);
		self.Plates[platenum] = nil;
	end

	if MovableMan:IsParticle(self.FactionIcons[platenum]) then
		MovableMan:RemoveParticle(self.FactionIcons[platenum]);
		self.FactionIcons[platenum] = nil;
	end

	if MovableMan:IsParticle(self.InfoPane[platenum]) then
		MovableMan:RemoveParticle(self.InfoPane[platenum]);
		self.InfoPane[platenum] = nil;
	end

	if MovableMan:IsParticle(self.MineDigit[platenum]) then
		MovableMan:RemoveParticle(self.MineDigit[platenum]);
		self.MineDigit[platenum] = nil;
	end
	
	if MovableMan:IsParticle(self.TrooperDigit[platenum]) then
		MovableMan:RemoveParticle(self.TrooperDigit[platenum]);
		self.TrooperDigit[platenum] = nil;
	end

	if MovableMan:IsParticle(self.TurretDigit[platenum]) then
		MovableMan:RemoveParticle(self.TurretDigit[platenum]);
		self.TurretDigit[platenum] = nil;
	end
	
	-- Frames in planet MOSParticles are set up as follows:
	-- 0 - Empty Idle
	-- 1 - Coalition borders
	-- 2 - Dummy borders
	-- 3 - Ronin borders
	-- 4 - Bearforce borders

	local preset , frame;

	preset = "Planet"..platenum;
	self.Plates[platenum] = CreateMOSRotating(preset , "UnmappedLands.rte");

	frame = 0;

	if self.Map[platenum]["Owner"] == self.Factions.COALITION then
		frame = 1;
	elseif self.Map[platenum]["Owner"] == self.Factions.DUMMY then
		frame = 2;
	elseif self.Map[platenum]["Owner"] == self.Factions.RONIN then
		frame = 3;
	elseif self.Map[platenum]["Owner"] == self.Factions.BEARFORCE then
		frame = 4;
	end

	self.Plates[platenum].Frame = frame;
	self.Plates[platenum].Pos = self.ElsPos[platenum];

	self.Plates[platenum].Pos = self.ElsPos[platenum] + Vector(0 , -(elevation));
	
	if platenum == self.PlayerIntentionTerritory then
		self.Plates[platenum].Pos = self.ElsPos[platenum] + Vector(0 , -5);
	end

	if isselected then
		self.Plates[platenum].Pos = self.ElsPos[platenum] + Vector(0 , -8);
	end

	if ispressed then
		self.Plates[platenum].Pos = self.ElsPos[platenum] + Vector(0 , -5);
	end
	MovableMan:AddParticle(self.Plates[platenum]);

	local drawinfo = false;
	
	if self.Map[platenum]["Owner"] == self.PlayerFaction then
		if self.InfoMode == 2 then
			drawinfo = true;
		else
			if isselected or ispressed then
				drawinfo = true;
			end

			if platenum == self.PlayerIntentionTerritory then
				drawinfo = true;
			end
		end
	end
	
	if drawinfo then
		self.InfoPane[platenum] = CreateMOSRotating("MapInfoBoard" , "UnmappedLands.rte");
		self.InfoPane[platenum].Pos = self.Plates[platenum].Pos + self.Els[platenum]["IconPos"][2];
		MovableMan:AddParticle(self.InfoPane[platenum]);
		
		self.MineDigit[platenum] = CreateMOSRotating("TextInfoBoard" , "UnmappedLands.rte");
		self.MineDigit[platenum].Pos = self.Plates[platenum].Pos + self.Els[platenum]["IconPos"][2] + Vector (27 , -9);
		self.MineDigit[platenum].Frame = self.Map[platenum]["Mines"];
		MovableMan:AddParticle(self.MineDigit[platenum]);

		self.TrooperDigit[platenum] = CreateMOSRotating("TextInfoBoard" , "UnmappedLands.rte");
		self.TrooperDigit[platenum].Pos = self.Plates[platenum].Pos + self.Els[platenum]["IconPos"][2] + Vector (27 , 0);
		self.TrooperDigit[platenum].Frame = self.Map[platenum]["Troopers"];
		MovableMan:AddParticle(self.TrooperDigit[platenum]);

		self.TurretDigit[platenum] = CreateMOSRotating("TextInfoBoard" , "UnmappedLands.rte");
		self.TurretDigit[platenum].Pos = self.Plates[platenum].Pos + self.Els[platenum]["IconPos"][2] + Vector (27 , 9);
		self.TurretDigit[platenum].Frame = 0; --self.Map[platenum]["Turrets"];
		MovableMan:AddParticle(self.TurretDigit[platenum]);
	end

	if self.Map[platenum]["Owner"] ~= self.Factions.NOBODY then
		preset = "FactionIcon"..self:FactionNumToStr(self.Map[platenum]["Owner"]);
		self.FactionIcons[platenum] = CreateMOSRotating(preset , "UnmappedLands.rte");
		self.FactionIcons[platenum].Pos = self.Plates[platenum].Pos + self.Els[platenum]["IconPos"][1];
		MovableMan:AddParticle(self.FactionIcons[platenum]);
	end
end

-----------------------------------------------------------------------------------------
-- Redraw mission plate
-----------------------------------------------------------------------------------------
function StrategyScreen:RedrawUIPlate(platenum , isselected , ispressed , elevation)
	print ("RedrawUIPlate");

	if MovableMan:IsParticle(self.Plates[platenum]) then
		MovableMan:RemoveParticle(self.Plates[platenum]);
		self.Plates[platenum] = nil;
	end

	if isselected then
		self.Plates[platenum] = CreateMOSRotating(self.Els[platenum]["Preset"].."MouseOver" , "UnmappedLands.rte");
		self.Plates[platenum].SpriteAnimMode = 1;
	else
		self.Plates[platenum] = CreateMOSRotating(self.Els[platenum]["Preset"].."Idle" , "UnmappedLands.rte");
	end

	if ispressed then
		self.Plates[platenum] = CreateMOSRotating(self.Els[platenum]["Preset"].."Pressed" , "UnmappedLands.rte");
	end

	self.Plates[platenum].Pos = self.ElsPos[platenum]
	MovableMan:AddParticle(self.Plates[platenum]);
end
-----------------------------------------------------------------------------------------
-- Remake next turn plate according to current intention state
-----------------------------------------------------------------------------------------
function StrategyScreen:RemakeNextTurnPlate(platenum , intention)
	print ("RemakeNextTurnPlate");

	if intention == self.Intentions.NONE then
	   self.Els[platenum]["Preset"] = "ButtonNextTurn";
	elseif intention == self.Intentions.ATTACK then
	   self.Els[platenum]["Preset"] = "ButtonAttack";
	elseif intention == self.Intentions.DEFEND then
	   self.Els[platenum]["Preset"] = "ButtonDefend";
	end
end
-----------------------------------------------------------------------------------------
-- Redraw one UI plate
-----------------------------------------------------------------------------------------
function StrategyScreen:RedrawPlate(platenum , isselected , ispressed , elevation)
	print ("RedrawPlate");

	if platenum >= 1 and platenum <= 10 then
		self:RedrawPlanetPlate(platenum , isselected , ispressed , elevation);
	end

	if platenum > 10 then
		self:RedrawUIPlate(platenum , isselected , ispressed , elevation);
	end
end
-----------------------------------------------------------------------------------------
-- Redraw all UI plates
-----------------------------------------------------------------------------------------
function StrategyScreen:RedrawAllPlates()
	print ("Redraw all plates");

	for i = 1, #self.Els do
		self:RedrawPlate(i , false , false , 0);
	end

	self:RedrawPlate(self.Selection , true , false , 0);
end
-----------------------------------------------------------------------------------------
-- Redraw turn points mark
-----------------------------------------------------------------------------------------
function StrategyScreen:RedrawTurnPoints()
	print ("RedrawTurnPoints");

	if MovableMan:IsParticle(self.TurnPointPlate) then
		MovableMan:RemoveParticle(self.TurnPointPlate);
		self.TurnPointPlate = nil;
	end

	self.TurnPointPlate = CreateMOSRotating("IconActionPoints" , "UnmappedLands.rte");
	self.TurnPointPlate.Frame = self.UsedTurnPoints;
	
	self.TurnPointPlate.Pos = self.Mid + Vector(321 , -53);
	MovableMan:AddParticle(self.TurnPointPlate);
end
-----------------------------------------------------------------------------------------
-- Converts faction string to faction ID
-----------------------------------------------------------------------------------------
function StrategyScreen:FactionStrToNum(faction)
	print ("FactionStrToNum");

	if faction == "Coalition" then
		return self.Factions.COALITION;
	elseif faction == "Dummy" then
		return self.Factions.DUMMY;
	elseif faction == "Ronin" then
		return self.Factions.RONIN;
	elseif faction == "Bearforce" then
		return self.Factions.BEARFORCE;
	elseif faction == "Nobody" then
		return self.Factions.NOBODY;
	end

	return nil;
end
-----------------------------------------------------------------------------------------
-- Converts faction ID to faction string
-----------------------------------------------------------------------------------------
function StrategyScreen:FactionNumToStr(faction)
	print ("FactionNumToStr");

	if faction == self.Factions.COALITION then
		return "Coalition";
	elseif faction == self.Factions.DUMMY then
		return "Dummy";
	elseif faction == self.Factions.RONIN then
		return "Ronin";
	elseif faction == self.Factions.BEARFORCE then
		return "Bearforce";
	elseif faction == self.Factions.NOBODY then
		return "Nobody";
	end

	return nil;
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function StrategyScreen:HasBoardersWith(terrnum , faction)
	print ("HasBoardersWith");

	print(terrnum);
	print(faction);
	print("#######");
	
	local lmap = {};

	for i = 1 , 10 do
		lmap[i] = 0;
	end
	
	for i = 1 , 10 do
		if self.Map[i]["Owner"] == faction then
			lmap[i] = 1;
			
			for j = 1, #self.Els[i]["NearLands"] do
				lmap[self.Els[i]["NearLands"][j]] = 1;
			end
		end
	end

	if lmap[terrnum] == 1 then
		return true;
	else
		return false;
	end
end
-----------------------------------------------------------------------------------------
-- Loads current game state from file
-----------------------------------------------------------------------------------------
function StrategyScreen:LoadGameState()
	print ("LoadGameState");

	self.GS = CF_ReadConfigFile(self.ModuleName , "CURRENT.dat");

	self:UpdateMapFromGameState();
	self.PlayerFaction = self:FactionStrToNum(self.GS["PlayerFaction"]);
	self.CPUFaction[1] = self:FactionStrToNum(self.GS["CPU1Faction"]);
	self.CPUFaction[2] = self:FactionStrToNum(self.GS["CPU2Faction"]);
	self.CPUFaction[3] = self:FactionStrToNum(self.GS["CPU3Faction"]);

	self.StrPlayerFaction = self:FactionNumToStr(self.PlayerFaction);
	self.StrCPUFaction[1] = self:FactionNumToStr(self.CPUFaction[1]);
	self.StrCPUFaction[2] = self:FactionNumToStr(self.CPUFaction[2]);
	self.StrCPUFaction[3] = self:FactionNumToStr(self.CPUFaction[3]);

	self:SetTeamFunds(tonumber(self.GS["PlayerGold"]) , self.PlayerTeam);

	self.TurnNumber = tonumber(self.GS["TurnNumber"]);
	self.DefaultSlot = tonumber(self.GS["DefaultSlot"]);
	self.Kills = tonumber(self.GS["Kills"]);
	self.Deaths = tonumber(self.GS["Deaths"]);

	self.PlayerAttackTerritory = tonumber(self.GS["PlayerAttackTerritory"]);
	self.PlayerDefendTerritory = tonumber(self.GS["PlayerDefendTerritory"]);

	self.PlayerIntention = self.Intentions.NONE;

	if self.PlayerAttackTerritory > 0 then
		self.PlayerIntention = self.Intentions.ATTACK;
		self.PlayerIntentionTerritory = self.PlayerAttackTerritory;
	end

	if self.PlayerDefendTerritory > 0 then
		self.PlayerIntention = self.Intentions.DEFEND;
		self.PlayerIntentionTerritory = self.PlayerDefendTerritory;
	end

	self.CPUAttackTerritory[1] = tonumber(self.GS["CPU1AttackTerritory"]);
	self.CPUAttackTerritory[2] = tonumber(self.GS["CPU2AttackTerritory"]);
	self.CPUAttackTerritory[3] = tonumber(self.GS["CPU3AttackTerritory"]);

	self.LastMissionTerritory = tonumber(self.GS["LastMissionTerritory"]);
	self.LastMissionAIBudget = tonumber(self.GS["LastMissionAIBudget"]);
	self.LastMissionCPUFaction = self:FactionStrToNum(self.GS["LastMissionCPUFaction"]);
	self.LastMissionResult = self.GS["LastMissionResult"];
	self.LastMissionLootCollected = tonumber(self.GS["LastMissionLootCollected"]);
	self.LastMissionInitiator = self:FactionStrToNum(self.GS["LastMissionInitiator"]);
	self.LastMissionOwnerOnVictory = self:FactionStrToNum(self.GS["LastMissionOwnerOnVictory"]);
	self.LastMissionOwnerOnDefeat = self:FactionStrToNum(self.GS["LastMissionOwnerOnDefeat"]);

	self.GoldPerMine = tonumber(self.GS["GoldPerMine"]);
	self.BrainCost = tonumber(self.GS["BrainCost"]);
	self.MineCost = tonumber(self.GS["MineCost"]);
	self.TrooperCost = tonumber(self.GS["TrooperCost"]);
	self.MaxTurnPoints = tonumber(self.GS["MaxTurnPoints"]);
	self.UsedTurnPoints = tonumber(self.GS["UsedTurnPoints"]);
	self.PointsPerAttack = tonumber(self.GS["PointsPerAttack"]);
	self.PointsPerDefence = tonumber(self.GS["PointsPerDefence"]);
	self.MaxMinesPerLand = tonumber(self.GS["MaxMinesPerLand"]);
	self.MaxTroopersPerLand = tonumber(self.GS["MaxTroopersPerLand"]);

	if self.GS["PlayerHasBrain"] == "true" then
		self.PlayerHasBrain = true;
	else
		self.PlayerHasBrain = false;
	end

	if self.GS["StartTurnProcessing"] == "true" then
		self.StartTurnProcessing = true;
	else
		self.StartTurnProcessing = false;
	end
end
-----------------------------------------------------------------------------------------
-- Saves current game state to file
-----------------------------------------------------------------------------------------
function StrategyScreen:SaveGameState()
	print ("SaveGameState");

	self:UpdateGameStateFromMap();

	self.GS["PlayerGold"] = self:GetTeamFunds(self.PlayerTeam);
	self.GS["PlayerFaction"] = self:FactionNumToStr(self.PlayerFaction);
	self.GS["CPU1Faction"] = self:FactionNumToStr(self.CPUFaction[1]);
	self.GS["CPU2Faction"] = self:FactionNumToStr(self.CPUFaction[2]);
	self.GS["CPU3Faction"] = self:FactionNumToStr(self.CPUFaction[3]);

	self.GS["PlayerGold"] = self:GetTeamFunds(self.PlayerTeam);

	self.GS["TurnNumber"] = self.TurnNumber;
	self.GS["DefaultSlot"] = self.DefaultSlot;
	self.GS["Kills"] = self.Kills;
	self.GS["Deaths"] = self.Deaths;

	self.GS["PlayerAttackTerritory"] = self.PlayerAttackTerritory;
	self.GS["PlayerDefendTerritory"] = self.PlayerDefendTerritory;
	self.GS["CPU1AttackTerritory"] = self.CPU1AttackTerritory;
	self.GS["CPU2AttackTerritory"] = self.CPU2AttackTerritory;
	self.GS["CPU3AttackTerritory"] = self.CPU3AttackTerritory;

	self.GS["CPU1AttackTerritory"] = self.CPUAttackTerritory[1];
	self.GS["CPU2AttackTerritory"] = self.CPUAttackTerritory[2];
	self.GS["CPU3AttackTerritory"] = self.CPUAttackTerritory[3];

	self.GS["CPU1AttackTerritory"] = self.CPUAttackTerritory[1];
	self.GS["CPU2AttackTerritory"] = self.CPUAttackTerritory[2];
	self.GS["CPU3AttackTerritory"] = self.CPUAttackTerritory[3];

	self.GS["LastMissionTerritory"] = self.LastMissionTerritory;
	self.GS["LastMissionAIBudget"] = self.LastMissionAIBudget;
	self.GS["LastMissionCPUFaction"] = self:FactionNumToStr(self.LastMissionCPUFaction);
	self.GS["LastMissionResult"] = self.LastMissionResult;
	self.GS["LastMissionLootCollected"] = self.LastMissionLootCollected;
	self.GS["LastMissionInitiator"] = self:FactionNumToStr(self.LastMissionInitiator);
	self.GS["LastMissionOwnerOnVictory"] = self:FactionNumToStr(self.LastMissionOwnerOnVictory);
	self.GS["LastMissionOwnerOnDefeat"] = self:FactionNumToStr(self.LastMissionOwnerOnDefeat);

	self.GS["GoldPerMine"] = self.GoldPerMine ;
	self.GS["BrainCost"] = self.BrainCost;
	self.GS["MineCost"] = self.MineCost;
	self.GS["TrooperCost"] = self.TrooperCost;
	self.GS["MaxTurnPoints"] = self.MaxTurnPoints;
	self.GS["UsedTurnPoints"] = self.UsedTurnPoints;
	self.GS["PointsPerAttack"] = self.PointsPerAttack;
	self.GS["PointsPerDefence"] = self.PointsPerDefence;
	self.GS["MaxMinesPerLand"] = self.MaxMinesPerLand;
	self.GS["MaxTroopersPerLand"] = self.MaxTroopersPerLand;

	if  self.PlayerHasBrain then
		self.GS["PlayerHasBrain"] = "true";
	else
		self.GS["PlayerHasBrain"] = "false";
	end

	if self.StartTurnProcessing then
		self.GS["StartTurnProcessing"] = "true";
	else
		self.GS["StartTurnProcessing"] = "false";
	end

	CF_WriteConfigFile(self.GS , self.ModuleName , "CURRENT.dat");
end
-----------------------------------------------------------------------------------------
-- Dumps text table with game state to binary map
-----------------------------------------------------------------------------------------
function StrategyScreen:UpdateMapFromGameState()
	print ("UpdateMapFromGameState");

	for i = 1, 10 do
		self.Map[i]["Owner"] = self:FactionStrToNum(self.GS["Planet"..i.."Owner"]);
		self.Map[i]["Mines"] = tonumber(self.GS["Planet"..i.."Mines"]);
		self.Map[i]["Troopers"] = tonumber(self.GS["Planet"..i.."Troopers"]);
	end
end
-----------------------------------------------------------------------------------------
-- Dumps binary map to text table with game state
-----------------------------------------------------------------------------------------
function StrategyScreen:UpdateGameStateFromMap()
	print ("UpdateGameStateFromMap");

	for i = 1, 10 do
		self.GS["Planet"..i.."Owner"] = self:FactionNumToStr(self.Map[i]["Owner"]);
		self.GS["Planet"..i.."Mines"] = tostring(self.Map[i]["Mines"]);
		self.GS["Planet"..i.."Troopers"] = tostring(self.Map[i]["Troopers"]);
	end
end
-----------------------------------------------------------------------------------------
-- Counts how many lands each player has. Returns player lands count and table with cpu lands count
-----------------------------------------------------------------------------------------
function StrategyScreen:CountLands()
	print ("CountLands");

	local playerlands = 0;
	local cpulands = {};

	for cpu = 1 , 2 , 3 do
		cpulands[cpu] = 0;
	end

	for i = 1 , 10 do
		if self.Map[i]["Owner"] == self.PlayerFaction then
			playerlands = playerlands + 1;
		end

		for cpu = 1 , 2 , 3 do
			if self.Map[i]["Owner"] == self.CPUFaction[cpu] then
				cpulands[cpu] = cpulands[cpu] + 1;
			end
		end
	end

	return playerlands , cpulands;
end
-----------------------------------------------------------------------------------------
-- Puts new user mine on the map
-----------------------------------------------------------------------------------------
function StrategyScreen:PutNewUserMine(terr)
	print ("PutNewUserMine");

	if self.UsedTurnPoints < self.MaxTurnPoints then
		if self.Map[terr]["Owner"] == self.PlayerFaction then
			if self:GetTeamFunds(self.PlayerTeam) >= self.MineCost then
				if self.Map[terr]["Mines"] < self.MaxMinesPerLand then
					self.Map[terr]["Mines"] = self.Map[terr]["Mines"] + 1;
					self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) - self.MineCost , self.PlayerTeam);
					self.UsedTurnPoints = self.UsedTurnPoints + 1;

					CF_UpdateLog(self.GS , self.StrPlayerFaction.." builds new mine at ".. self.Els[terr]["Name"]..".");

					self:RedrawPlate(terr , false , false , 0);
					self:RedrawTurnPoints();
				else
					CF_UpdateLog(self.GS , "Mine limit for this territory reached.");
				end
			else
				CF_UpdateLog(self.GS , "Not enough gold. You need "..self.MineCost.." oz of gold to build a mine.");
			end
		else
			CF_UpdateLog(self.GS , "You can't build mines on foreign lands.");
		end
	else
		CF_UpdateLog(self.GS , "Not enough points to build mine, start new turn.");
	end
end
-----------------------------------------------------------------------------------------
-- Puts new user mine on the map
-----------------------------------------------------------------------------------------
function StrategyScreen:PutNewUserTrooper(terr)
	print ("PutNewUserTrooper");

	if self.UsedTurnPoints < self.MaxTurnPoints then
		if self.Map[terr]["Owner"] == self.PlayerFaction then
			if self:GetTeamFunds(self.PlayerTeam) >= self.TrooperCost then
				if self.Map[terr]["Troopers"] < self.MaxTroopersPerLand then
					self.Map[terr]["Troopers"] = self.Map[terr]["Troopers"] + 1;
					self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) - self.TrooperCost , self.PlayerTeam);
					self.UsedTurnPoints = self.UsedTurnPoints + 1;

					CF_UpdateLog(self.GS , self.StrPlayerFaction.." reinforces ".. self.Els[terr]["Name"]..".");

					self:RedrawPlate(terr , false , false , 0);
					self:RedrawTurnPoints();
				else
					CF_UpdateLog(self.GS , "Garrison limit for this territory reached.");
				end
			else
				CF_UpdateLog(self.GS , "Not enough gold. You need "..self.TrooperCost.." oz of gold to enforce.");
			end
		else
			CF_UpdateLog(self.GS , "You can't garrison foreign lands.");
		end
	else
		CF_UpdateLog(self.GS , "Not enough points to enforce, start new turn.");
	end
end
-----------------------------------------------------------------------------------------
-- Initiates a new turn, zeroes all necessary variables, checks for win\loose conditions
-----------------------------------------------------------------------------------------
function StrategyScreen:StartNewTurn()
	print ("StartNewTurn");

	self.TurnNumber = self.TurnNumber + 1;

	local playerlands = 0;
	local playermines = 0;
	local cpulands = {};
	local fundstoadd = 0;

	playerlands , cpulands = self:CountLands();

	for i = 1, 10 do
		if self.Map[i]["Owner"] == self.PlayerFaction then
			playermines = playermines + self.Map[i]["Mines"];
		end
	end

	-- TO CHANGE!!!!
	fundstoadd = playermines * self.GoldPerMine;

	self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + fundstoadd , self.PlayerTeam);

	CF_UpdateLog(self.GS , "Turn #"..self.TurnNumber..". "..fundstoadd.." oz of gold collected from "..playermines.." mines.");

	if not self.PlayerHasBrain then
		if self:GetTeamFunds(self.PlayerTeam) >= self.BrainCost then
			self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) - self.BrainCost , self.PlayerTeam);
			CF_UpdateLog(tostring(self.BrainCost).." oz of gold spent for new commander.");
			self.PlayerHasBrain = true;
		else
			CF_UpdateLog("No gold for new commander, missions unavalable!");
		end
	end

	-- Check for victory
	if cpulands[1] == 0 and cpulands[2] and cpulands[3] == 0 then
		self.WinnerTeam = self.PlayerTeam;
		ActivityMan:EndActivity();

		self.ControlsEnabled = false;
	end

	-- Check for defeat
	if playerlands == 0 then
		self.WinnerTeam = self.CPUTeam;
		ActivityMan:EndActivity();

		self.ControlsEnabled = false;
	end

	local oldintention = self.PlayerIntentionTerritory;

	self.UsedTurnPoints = 0;
	self:RedrawTurnPoints();

	self.PlayerIntention = self.Intentions.NONE;
	self.PlayerIntentionTerritory = 0;

	self:RedrawPlate(oldintention , false , false , 0);
	self:RemakeNextTurnPlate(11 , self.PlayerIntention);
	self:RedrawPlate(11 , true , false , 0);
	self:SwitchToActor(self.brain,Activity.PLAYER_1,-1);

	self:SaveGameState();
end
-----------------------------------------------------------------------------------------
-- Deferred iterative turn processing which is launched until no turn actions left uncomplete
-----------------------------------------------------------------------------------------
function StrategyScreen:DoTurnProcessing()
	print ("DoTurnProcessing");

	local logrec = "!!!SOME NASTY ERROR!!!";
	local playerlands , cpulands;

	playerlands , cpulands = self:CountLands();
	self.ControlsEnabled = false;
	self.MissionActivityToLaunch = "";

	if self.LastMissionTerritory ~= 0 then
		print ("Last mission processing");
		print ("LastMisisonResult"..self.LastMissionResult);
		if self.LastMissionResult == "Victory" then

			self.Map[self.LastMissionTerritory]["Owner"] = self.LastMissionOwnerOnVictory;
			self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.LastMissionLootCollected , self.PlayerTeam);
			logrec = "Mission at ".. self.Els[self.LastMissionTerritory]["Name"] .." sucessfull! "..
				self.LastMissionLootCollected.." oz of gold collected";
			
			self.PlayerAttackTerritory = 0;
		elseif self.LastMissionResult == "Defeat" then

			self.Map[self.LastMissionTerritory]["Owner"] = self.LastMissionOwnerOnDefeat;
			self.Map[self.LastMissionTerritory]["Troopers"] = 0;

			logrec = "Mission at ".. self.Els[self.LastMissionTerritory]["Name"] .." failed!";

			if self:GetTeamFunds(self.PlayerTeam) >= self.BrainCost then
				self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) - self.BrainCost , self.PlayerTeam);
				logrec = logrec.." "..self.BrainCost.." oz of gold spent for new commander."
				self.PlayerHasBrain = true;
			else
				self.PlayerHasBrain = false;
				logrec = logrec.." No gold for new commander, missions unavalable!"
			end

			self.PlayerAttackTerritory = 0;
		elseif self.LastMissionResult == "Retreat" then

			self.Map[self.LastMissionTerritory]["Owner"] = self.LastMissionOwnerOnDefeat;
			self.Map[self.LastMissionTerritory]["Troopers"] = 0;

			logrec = "Forces from ".. self.Els[self.LastMissionTerritory]["Name"] .." retreated!";

			self.PlayerAttackTerritory = 0;
		elseif self.LastMissionResult == "None" then
			-- Mission never ended, restart the mission
			
			-- Find cpu number who is the owner of attacked land
			local terrcpunumber;

			for cpu = 1,2,3 do
				if self.Map[self.LastMissionTerritory]["Owner"] == self.CPUFaction[cpu] then
					terrcpunumber = cpu;
				end
			end

			-- If this is the last CPU territory then start Last Stand mission
			if cpulands[cpu] == 1 then
				self.MissionActivityToLaunch = self.StrCPUFaction[cpu].."LastStandMission";
			else
				self.MissionActivityToLaunch =
					self.Els[self.LastMissionTerritory]["AttackActivity"];
			end
			print("MissionActivityToLaunch = ".. self.MissionActivityToLaunch);
			return;
		end

		CF_UpdateLog(self.GS , logrec);

		self:RedrawPlate(self.LastMissionTerritory, false , false , 0);
		self.LastMissionTerritory = 0;

		self.TurnProcessingDelayTimer:Reset();
		return;
	end

	-- Process player attack intentions
	if self.PlayerAttackTerritory ~= 0 then
		if self.Map[self.PlayerAttackTerritory]["Owner"] == self.Factions.NOBODY then
			self.Map[self.PlayerAttackTerritory]["Owner"] = self.PlayerFaction;

			logrec = self.StrPlayerFaction.." occupied "..self.Els[self.PlayerAttackTerritory]["Name"];

			self:RedrawPlate(self.PlayerAttackTerritory, false , false , 0);
			self.PlayerAttackTerritory = 0;

			CF_UpdateLog(self.GS , logrec);
			self.TurnProcessingDelayTimer:Reset();
			return;
		else
			print ("Player attack processing");

			-- Find cpu number who is the owner of attacked land
			local terrcpunumber;

			for cpu = 1,2,3 do
				if self.Map[self.PlayerAttackTerritory]["Owner"] == self.CPUFaction[cpu] then
					terrcpunumber = cpu;
				end
			end

			-- If this is the last CPU territory then start Last Stand mission
			if cpulands[cpu] == 1 then
				self.MissionActivityToLaunch = self.StrCPUFaction[cpu].."LastStandMission";
			else
				self.MissionActivityToLaunch =
					self.Els[self.PlayerAttackTerritory]["AttackActivity"];
			end
			print("MissionActivityToLaunch = ".. self.MissionActivityToLaunch);

			self.LastMissionTerritory = self.PlayerAttackTerritory;
			self.LastMissionResult = "None";
			self.LastMissionLootCollected = 0;
			self.LastMissionInitiator = self.PlayerFaction;
			self.LastMissionCPUFaction = self.Map[self.PlayerAttackTerritory]["Owner"];
			self.LastMissionOwnerOnVictory = self.PlayerFaction;
			self.LastMissionOwnerOnDefeat = self.Map[self.PlayerAttackTerritory]["Owner"];

			self.PlayerAttackTerritory = 0;
			self.TurnProcessingDelayTimer:Reset();
			return;
		end
	end

	-- Process player defence intentions
	if self.PlayerDefendTerritory ~= 0 then
		print ("Player defend processing");
		for cpu = 1 , 2 , 3 do
			if self.PlayerDefendTerritory == self.CPUAttackTerritory[cpu] then

				logrec = self.StrPlayerFaction.." defended ".. self.Els[self.PlayerDefendTerritory]["Name"]..
					" from "..self.StrCPUFaction[cpu];

				self.CPUAttackTerritory[cpu] = 0;
				CF_UpdateLog(self.GS , logrec);
			end
		end

		self.PlayerDefendTerritory = 0;

		self.TurnProcessingDelayTimer:Reset();
		return;
	end


	-- Process CPU intentions
	local othercpu;
	for cpu = 1 , 2 , 3 do
		if cpu == 1 then
			othercpu = 2 , 3;
		elseif cpu == 2 then
			othercpu = 1 , 3;
		elseif cpu == 3 then
			othercpu = 2 , 1;	
		end

		if self.CPUAttackTerritory[cpu] ~= 0 then
			print ("CPU "..cpu.." attack processing");
			print ("self.CPUAttackTerritory"..cpu.. " ".. tostring(self.CPUAttackTerritory[cpu]));
			if self.Map[self.CPUAttackTerritory[cpu]]["Owner"] == self.PlayerFaction then
				print ("CPU"..cpu.." Attacks P1");
				if self.PlayerHasBrain then
					print ("CPU "..cpu.." attacks P1 mission to be launched");
					self.MissionActivityToLaunch = "Defence0"..math.ceil(math.random(7));
					print (self.MissionActivityToLaunch);

					self.LastMissionAIBudget = 800 + cpulands[cpu] * 500 + self.TurnNumber * 150;

					print (self.MissionActivityToLaunch.." cpulands "..cpulands[cpu].." turnnumber "..self.TurnNumber.." budget "..self.LastMissionAIBudget);

					self.LastMissionTerritory = self.CPUAttackTerritory[cpu];
					self.LastMissionResult = "None";
					self.LastMissionLootCollected = 0;
					self.LastMissionInitiator = self.CPUFaction[cpu];
					self.LastMissionCPUFaction = self.CPUFaction[cpu];
					self.CPUAttackTerritory[cpu] = 0;
					self.LastMissionOwnerOnVictory = self.PlayerFaction;
					self.LastMissionOwnerOnDefeat = self.CPUFaction[cpu];
				else
					print ("CPU "..cpu.." attacks P1 who has no commander");
					self.Els[self.CPUAttackTerritory[cpu]]["Owner"] = self.CPUFaction[cpu];
					logrec = self.StrCPUFaction[cpu].." conquered "..self.Els[self.CPUAttackTerritory[cpu]]["Name"]..". "..
						self.StrPlayerFaction.." haven't commander to defend!";

					CF_UpdateLog(self.GS , logrec);

					self.CPUAttackTerritory[cpu] = 0;
				end
			elseif self.Map[self.CPUAttackTerritory[cpu]]["Owner"] == self.CPUFaction[othercpu] then
				print ("CPU"..cpu.." Attacks CPU"..othercpu);
				local logrec;
				if math.random() < 0.50 then
					self.Map[self.CPUAttackTerritory[cpu]]["Owner"] = self.CPUFaction[cpu];

					print("CPU"..cpu.." victory");
					logrec =
						self.StrCPUFaction[cpu].." conquered "..self.StrCPUFaction[othercpu].."'s "..self.Els[self.CPUAttackTerritory[cpu]]["Name"];
				else
					print("CPU"..othercpu.." victory");
					logrec =
						self.StrCPUFaction[othercpu].." defended "..self.Els[self.CPUAttackTerritory[cpu]]["Name"].." from "..self.StrCPUFaction[cpu];
				end

				self:RedrawPlate(self.CPUAttackTerritory[cpu], false , false , 0);
				CF_UpdateLog(self.GS , logrec);
				self.CPUAttackTerritory[cpu] = 0;
			elseif self.Map[self.CPUAttackTerritory[cpu]]["Owner"] == self.Factions.NOBODY then
				print ("CPU"..cpu.." Attacks nobody");
				self.Map[self.CPUAttackTerritory[cpu]]["Owner"] = self.CPUFaction[cpu];

				logrec =
					self.StrCPUFaction[cpu].." occupied "..self.Els[self.CPUAttackTerritory[cpu]]["Name"];

				self:RedrawPlate(self.CPUAttackTerritory[cpu], false , false , 0);
				CF_UpdateLog(self.GS , logrec);
				self.CPUAttackTerritory[cpu] = 0;
			end

			self.TurnProcessingDelayTimer:Reset();
			return;
		end
	end

	self.StartTurnProcessing = false;
	self.ControlsEnabled = true;
	
	self:StartNewTurn();
end
-----------------------------------------------------------------------------------------
-- Initiates current turn processing, selects lands for CPU's to attack, initiates next turn
-----------------------------------------------------------------------------------------
function StrategyScreen:NextTurn()
	print ("NextTurn");

	local playerlands = 0;
	local cpulands = {};
	local cpuminesbuilt = {};

	playerlands , cpulands = self:CountLands();

	-- Select targets for AI to attack
	for cpu = 1 , 2 , 3 do
		self.CPUAttackTerritory[cpu] = 0;
		cpuminesbuilt[cpu] = 0;
	end


	-- Select territories to attack for CPU. It could not match any other CPU selected lands or player selected lands
	for cpu = 1 , 2 , 3 do
		if cpulands[cpu] > 0 then
			while self.CPUAttackTerritory[cpu] == 0 do
				for i = 1 , 10 do
					if self.Map[i]["Owner"] ~= self.CPUFaction[cpu] then
						if self:HasBoardersWith(i , self.CPUFaction[cpu]) then
							-- select land to attack
							local p; -- Probability to select area for attack
							p = 0;
							if self.Map[i]["Owner"] == self.Factions.NOBODY then
								p = p + 0.75;
							else
								p = p + 0.10;
							end

							-- Increase probability to attack rich lands
							if self.Map[i]["Mines"] == self.MaxMinesPerLand then
								p = p + 0.20;
							end

							if self.Map[i]["Mines"] == self.MaxMinesPerLand - 1 then
								p = p + 0.10;
							end

							if math.random() < p then
								self.CPUAttackTerritory[cpu] = i;
								if i == self.PlayerIntentionTerritory and self.PlayerIntention == self.Intentions.ATTACK then
									self.CPUAttackTerritory[cpu] = 0;
								end

								if cpu == 2 and i == self.CPUAttackTerritory[1] then
									self.CPUAttackTerritory[cpu] = 0;
								end
							end
						end
					else
					-- Select land to build mine on it
						if cpuminesbuilt[cpu] < 2 then
							local p;

							if self.Map[i]["Mines"] == 0 then
								p = 1.01;
							else
								p = 0.15;
							end

							if math.random() < p then
								if self.Map[i]["Mines"] < self.MaxMinesPerLand then
									self.Map[i]["Mines"] = self.Map[i]["Mines"] + 1;
									cpuminesbuilt[cpu] = cpuminesbuilt[cpu] + 1;

									CF_UpdateLog(self.GS , self.StrCPUFaction[cpu].." builds new mine at ".. self.Els[i]["Name"]..".");

									self:RedrawPlate(i , false , false , 0);
								end
							end
						end -- if else
					end -- for
				end -- if self.Map
			end -- while
			print("CPU "..cpu.." attacks "..self.CPUAttackTerritory[cpu]);
		else
			print("CPU "..cpu.." has no territories");
		end
	end

	for cpu = 1 , 2 , 3 do
		if self.CPUAttackTerritory[cpu] ~= 0 then
			CF_UpdateLog(self.GS , self.StrCPUFaction[cpu].." attacks ".. self.Els[self.CPUAttackTerritory[cpu]]["Name"]..".");
		end
	end
	
	if self.PlayerIntention == self.Intentions.ATTACK then
		self.PlayerAttackTerritory = self.PlayerIntentionTerritory;
		self.PlayerDefendTerritory = 0;
	elseif self.PlayerIntention == self.Intentions.DEFEND then
		self.PlayerAttackTerritory = 0;
		self.PlayerDefendTerritory = self.PlayerIntentionTerritory;
	else
		self.PlayerAttackTerritory = 0;
		self.PlayerDefendTerritory = 0;
	end

	self.StartTurnProcessing = true;
end
-----------------------------------------------------------------------------------------
-- Processes presses on the planet tiles
-----------------------------------------------------------------------------------------
function StrategyScreen:PressPlanetPlate(platenum)
	print ("PressPlanetPlate");

	local logrecord;
	local oldintention;

	oldintention = self.PlayerIntentionTerritory;

	if platenum ~= self.PlayerIntentionTerritory then
		if self.PlayerIntention == self.Intentions.ATTACK then
			logrecord = self.Els[self.PlayerIntentionTerritory]["Name"].." attack cancelled.";
			CF_UpdateLog(self.GS , logrecord);
		end

		if self.PlayerIntention == self.Intentions.DEFEND then
			logrecord = self.Els[self.PlayerIntentionTerritory]["Name"].." defence cancelled.";
			CF_UpdateLog(self.GS , logrecord);
		end

		if self.Map[platenum]["Owner"] == self.PlayerFaction then
			local playerlands;

			playerlands = self:CountLands();


			if self.MaxTurnPoints - self.UsedTurnPoints < self.PointsPerDefence then
				self.PlayerIntention = self.Intentions.NONE;
				self.PlayerIntentionTerritory = platenum;
			else
				if playerlands == 1 then
					self.PlayerIntention = self.Intentions.NONE;
					-- self.PlayerIntentionTerritory = 0;
					logrecord = "You can't defend your last territory against overwhelming enemies!";
					CF_UpdateLog(self.GS , logrecord);
				else
					if self.PlayerHasBrain then
						self.PlayerIntention = self.Intentions.DEFEND;
						self.PlayerIntentionTerritory = platenum;
						logrecord = self.StrPlayerFaction.." defend "..
							self.Els[platenum]["Name"];
						CF_UpdateLog(self.GS , logrecord);
					else
						self.PlayerIntention = self.Intentions.NONE;
						self.PlayerIntentionTerritory = 0;
						logrecord = "No gold for new commander, you can't defend!";
						CF_UpdateLog(self.GS , logrecord);
					end
				end
			end
		else
			if self.MaxTurnPoints - self.UsedTurnPoints < self.PointsPerAttack then
				self.PlayerIntention = self.Intentions.NONE;
			else
				if self.PlayerHasBrain then
					self.PlayerIntention = self.Intentions.ATTACK;
					self.PlayerIntentionTerritory = platenum;
					logrecord = self.StrPlayerFaction.." attack "..
						self.Els[platenum]["Name"].." owned by "..
						self:FactionNumToStr(self.Map[platenum]["Owner"]);
					CF_UpdateLog(self.GS , logrecord);
				else
					self.PlayerIntention = self.Intentions.NONE;
					self.PlayerIntentionTerritory = 0;
					logrecord = "No gold for new commander, missions unavalable!";
					CF_UpdateLog(self.GS , logrecord);
				end
			end
		end

		-- Redraw old selected territory
		if oldintention > 0 and oldintention ~= self.PlayerIntentionTerritory then
			self:RedrawPlate(oldintention , false , false , 0);
		end

		self:RemakeNextTurnPlate(11 , self.PlayerIntention);
		self:RedrawPlate(11 , false , false , 0);
	else
		if self.PlayerIntention == self.Intentions.ATTACK then
			logrecord = self.Els[self.PlayerIntentionTerritory]["Name"].." attack cancelled.";
			CF_UpdateLog(self.GS , logrecord);
		end

		if self.PlayerIntention == self.Intentions.DEFEND then
			logrecord = self.Els[self.PlayerIntentionTerritory]["Name"].." defence cancelled.";
			CF_UpdateLog(self.GS , logrecord);
		end

		self.PlayerIntention = self.Intentions.NONE;
		self.PlayerIntentionTerritory = 0;

		self:RemakeNextTurnPlate(11 , self.PlayerIntention);
		self:RedrawPlate(11 , false , false , 0);
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function StrategyScreen:UpdateActivity()
	self:ClearObjectivePoints();
	
	if self.StartLoadScreen then
		if not self.NullState then
			self:SaveGameState();
		end
		ActivityMan:EndActivity();
		ActivityMan:StartActivity("GAScripted" , "LoadScreen");
		return;
	end

	if self.StartSaveScreen then
		self:SaveGameState();
		ActivityMan:EndActivity();
		ActivityMan:StartActivity("GAScripted" , "SaveScreen");
		return;
	end

	if self.HelpTimer:IsPastSimMS(5000) then
		FrameMan:SetScreenText(self.Els[self.Selection]["Description"]..CF_GetPrintableLogPart(self.GS , self.LogLinesToShow), Activity.PLAYER_1, 0, 1, false);
	else
		FrameMan:SetScreenText(self.HelpText..self.Els[self.Selection]["Description"]..CF_GetPrintableLogPart(self.GS , self.LogLinesToShow), Activity.PLAYER_1, 0, 1, false);
	end

	if self.RefreshGlowTimer:IsPastSimMS(9980) then
		self:RefreshGlow();
		self.RefreshGlowTimer:Reset();
	end

	if self.StartTurnProcessing then
		if self.TurnProcessingDelayTimer:IsPastSimMS(1700) then
			self:DoTurnProcessing();
			-- self.StartTurnProcessing = false; -- debug
			-- self.ControlsEnabled = true; -- debug

			if self.MissionActivityToLaunch ~= "" then
				--Start mission activity
				self:SaveGameState();
				ActivityMan:EndActivity();
				ActivityMan:StartActivity("GAScripted" , self.MissionActivityToLaunch);
				return;

				-- Do random victory for player -- DEBUG
				--[[if self.LastMissionTerritory ~= 0 then
					if math.random() < 0.70 then
						self.LastMissionResult = "Victory";
						self.LastMissionLootCollected = math.random(500);
					else
						if math.random() < 0.50 then
							self.LastMissionResult = "Defeat";
						else
							self.LastMissionResult = "Retreat";
						end
					end
				end--]]--
			end
		end
	end

	if self.ControlPressed > 0 then
		if self.UITimer:IsPastSimMS(250) then
			self:RedrawPlate(self.ControlPressed , true , false , 0);

			if self.ControlPressed >= 1 and self.ControlPressed <= 10 then
				if self:HasBoardersWith(self.ControlPressed , self.PlayerFaction) then
					self:PressPlanetPlate(self.ControlPressed);
				else
					CF_UpdateLog(self.GS , "This territory is too far!");
				end
			end

			if self.ControlPressed == 11 then
				CF_UpdateLog(self.GS , "End of turn! Turn processing initiated...");
				self:NextTurn();
			end

			if self.ControlPressed == 13 then
				self.StartLoadScreen = true;
			end

			if self.ControlPressed == 16 then
				if self.InfoMode == 0 then
					self.LogLinesToShow = 14;
					self.InfoMode = 1;
				elseif self.InfoMode == 1 then
					self.LogLinesToShow = 4;
					self.InfoMode = 2;

					self:RedrawAllPlates();
					if self.PlayerIntentionTerritory > 0 then
						self:RedrawPlate(self.PlayerIntentionTerritory , false , false , 0);
					end
				elseif self.InfoMode == 2 then
					self.InfoMode = 0;

					self:RedrawAllPlates();
					if self.PlayerIntentionTerritory > 0 then
						self:RedrawPlate(self.PlayerIntentionTerritory , false , false , 0);
					end
				end
			end
			
			if self.ControlPressed == 14 then
				if self.PlayerIntentionTerritory > 0 then
					self:PutNewUserMine(self.PlayerIntentionTerritory);

					if self.UsedTurnPoints == 4 then
						CF_UpdateLog(self.GS , "Too many points spent. You can't launch attack or defence operations.");
						self.PlayerIntention = self.Intentions.NONE;
						self:RemakeNextTurnPlate(11 , self.PlayerIntention);
						self:RedrawPlate(11 , false , false , 0);
					end
				else
					CF_UpdateLog(self.GS , "Territory not selected!");
				end
			end

			if self.ControlPressed == 15 then
				if self.PlayerIntentionTerritory > 0 then
					self:PutNewUserTrooper(self.PlayerIntentionTerritory);

					if self.UsedTurnPoints == 4 then
						CF_UpdateLog(self.GS , "Too many points spent. You can't launch attack or defence operations.");
						self.PlayerIntention = self.Intentions.NONE;
						self:RemakeNextTurnPlate(11 , self.PlayerIntention);
						self:RedrawPlate(11 , false , false , 0);
					end
				else
					CF_UpdateLog(self.GS , "Territory not selected!");
				end
			end

			if self.ControlPressed == 12 then
				self.StartSaveScreen = true;
			end

			self.ControlsEnabled = true;
			self.ControlPressed = 0;
		end
	end

	if self.ControlsEnabled then
		if self.GenericTimer:IsPastSimMS(250) then
			--Move the cursor.
			local cont = self.brain:GetController();

			if cont:IsState(Controller.PRESS_LEFT) then
				self:RedrawPlate(self.Selection , false , false , 0);

				if self.PlayerIntentionTerritory > 0 then
					self:RedrawPlate(self.PlayerIntentionTerritory , false , false , 0);
				end

				self.Selection = self.Els[self.Selection]["NextPlate"][1];
				self:RedrawPlate(self.Selection , true , false , 0);
			end

			if cont:IsState(Controller.PRESS_RIGHT) then
				self:RedrawPlate(self.Selection , false , false , 0);

				if self.PlayerIntentionTerritory > 0 then
					self:RedrawPlate(self.PlayerIntentionTerritory , false , false , 0);
				end

				self.Selection = self.Els[self.Selection]["NextPlate"][2];
				self:RedrawPlate(self.Selection , true , false , 0);
			end

			if cont:IsState(Controller.PRESS_UP) then
				self:RedrawPlate(self.Selection , false , false , 0);

				if self.PlayerIntentionTerritory > 0 then
					self:RedrawPlate(self.PlayerIntentionTerritory , false , false , 0);
				end

				self.Selection = self.Els[self.Selection]["NextPlate"][3];
				self:RedrawPlate(self.Selection , true , false , 0);
			end

			if cont:IsState(Controller.PRESS_DOWN) then
				self:RedrawPlate(self.Selection , false , false , 0);

				if self.PlayerIntentionTerritory > 0 then
					self:RedrawPlate(self.PlayerIntentionTerritory , false , false , 0);
				end

				self.Selection = self.Els[self.Selection]["NextPlate"][4];
				self:RedrawPlate(self.Selection , true , false , 0);
			end

			--If fire has been pushed, start mission.
			if cont:IsState(Controller.WEAPON_FIRE) then
				self.ControlPressed = self.Selection;
				self.ControlsEnabled = false;
				self.UITimer:Reset();
				self:RedrawPlate(self.Selection , false , true , 0);
				self.GenericTimer:Reset();
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Thats all folks!!!
-----------------------------------------------------------------------------------------